<?php
	// $Id: rebuild.php 314 2015-03-31 04:39:25Z robert0609 $
	// Copyright BRAEWORKS (R) 2015
	// CLI rebuild setup

error_reporting(E_ALL | E_STRICT);

define('CLI_MODE', true);	// tell configure not to crash

require_once 'includes/configure.php';
require_once LM_FS_INCLUDES_DIR . 'auto_class_loader.php';

echo 'Starting -> rebuilding setup for ' . LM_PROJECT_SHORTNAME . ' ' . LM_PROJECT_VERSION . '.' . "\n";
Clm::$cDB->logEvent('CLI: Starting -> rebuilding setup for ' . LM_PROJECT_SHORTNAME . ' ' . LM_PROJECT_VERSION . '.');

if(Clm::do_lm_warnings(true)) {
	Clm::$cDB->checkDBversion(true);
	} // if

$msgs = Clm::getMsgs();
$msgs = preg_replace('/\<br\>|\<br\/\>|\<\/p\>|\<\/tr\>/i', "\n",  strip_tags($msgs));
$msgs = preg_replace('/&nbsp;/i', '', $msgs);
echo $msgs;

echo 'Finished -> rebuilding setup for ' . LM_PROJECT_SHORTNAME . ' ' . LM_PROJECT_VERSION . '.' . "\n";
Clm::$cDB->logEvent('CLI: Finished -> rebuilding setup for ' . LM_PROJECT_SHORTNAME . ' ' . LM_PROJECT_VERSION . '.');

exit(0);

// eof
