<?php
	// $Id: app_page_footer.php 410 2016-10-11 13:04:28Z robert0609 $
	// Copyright BRAEWORKS (R) 2013

?>

<?php Clm::page_start_comment(__FILE__); ?>
	<div id="footer">
		<table class="page_bottom">
			<?php if(Clm::is_browser_html5()) echo '<caption>Page footer</caption>'; ?>
			<tr class="page_bottom">
				<td>&nbsp;</td>
				<td class="page_bottom" style="width: 35%; text-align: left;">
		<?php	if(strlen(LMC_DISCLAIMER_LINK_NAME) > 0) { ?>
					<a href="<?php echo ((strlen(LMC_DISCLAIMER_LINK) > 4) ? LMC_DISCLAIMER_LINK:'index.php?action=disclaimer'); ?>"><?php echo LMC_DISCLAIMER_LINK_NAME; ?></a>
		<?php		} echo '&nbsp;'; ?>
				</td>
				<td class="page_bottom" style="text-align: center;">
					<?php
						echo '&copy; ' . date('Y') . ' ';
						if(strlen(LMC_WEB_SITE_ADDRESS) > 4) {
							echo '<a href="' . LMC_WEB_SITE_ADDRESS . '" target="_blank">' . trim(LMC_CO_NAME) . '</a>';
							} // if
						else echo trim(LMC_CO_NAME);
					?>
				</td>
				<td class="page_bottom" style="width: 35%; text-align: right;">
<?php if((INI_ALLOW_ABOUT_MANUAL_LINKS_BOOL) || (Clm::is_user_logged_in())) { ?>
					<a href="index.php?action=about_lm" title="About <?php echo Clm::$version_str; ?>">
						<?php echo LM_PROJECT_SHORTNAME . (INI_DEBUG_BOOL ? ' (Debug)':'') . ' ' . LM_PROJECT_VERSION; ?>
					</a>
<?php	} else echo (INI_DEBUG_BOOL ? ' (Debug)':'&nbsp;'); ?>
				</td>
				<td>&nbsp;</td>
			</tr>
			<tr class="page_bottom">
				<td>&nbsp;</td>
				<td class="page_bottom" style="width: 35%; text-align: left;">
					<?php include "includes/visitor_cntr.php"; ?>
				</td>
				<td class="page_bottom" style="text-align: center;">
					<?php echo Clm::show_stats(); ?>
				</td>
				<td class="page_bottom" style="width: 35%; text-align: right;">
					<?php if(LMC_SHOW_COOKIE_COUNTER) { ?>
					<script type="text/javascript"><!--
						showClientVisitsCntrCookie("visits","You have previously visited","times.",<?php echo LMC_SHOW_COOKIE_COUNTER; ?>);
					// --></script>
					<noscript> </noscript>
					<?php	} else echo '&nbsp;'; // no cookie access ?>
				</td>
				<td>&nbsp;</td>
			</tr>
		</table>
	</div>
<?php Clm::page_end_comment(__FILE__); ?>
