<?php

/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

/**
 * Description of box_tool_tips
 *
 * @author robert0609
 */

class Cbox_tool_tips {
	//put your code here
	
	protected static $outer_class = 'box_outer_tip';
	protected static $inner_class = 'box_inner_tip';

	public function __construct() {
		self::init();
		} // __construct()

	public function __destruct() {

		} // __destruct()

//	public static function get_styles($prnFlg = true) {
//		if(self::$styles_output) return '';	// done already
//		self::$styles_output = true;
//	$text = <<< EOT
//	<style type="text/css">
//	</style>
//EOT;
//		if(!$prnFlg) return $text;
//		echo $text;
//		return '';
//		} // get_styles()
	
	protected static function wrap($tip,$wrap) {
		if((int)$wrap < 10) return $tip;
		// ok wrap it
		$tip = preg_replace('/<br>|<br\/>|<br \/>|&#10;/i',"\n", $tip);
		$tip = wordwrap($tip, $wrap, "\n",true);
//		$tip = htmlentities($tip);
		$tip = nl2br($tip);
		return $tip;
		} // wrap()
	
	public static function anchor($url,$value,$tip, $wrap = 0, $outer_class = '', $inner_class = '') {
		if((!Clm::is_hover_boxes_ok()) || (empty($value))) return '';
		$text = '<a class="' . self::$outer_class . (!empty($outer_class) ? ' ' . $outer_class:'') . '" href="' . $url . '">' . "\n" .
				'	' . $value . "\n" .
				'	<span class="' . self::$inner_class . (!empty($inner_class) ? ' ' . $inner_class:'') . '">' . "\n" .
				'		' . self::wrap($tip, $wrap) . "\n" .
				'	</span>' . "\n" .
				'</a>' . "\n";
		return $text;
		} // anchor()
		
	public static function block($value,$tip, $left_fill = '', $wrap = 0, $outer_class = '', $inner_class = '', $table_class = '') {
		if(!Clm::is_hover_boxes_ok()) return '';
		if(empty($value)) $value = '&nbsp;&nbsp;';
		if(empty($left_fill)) $left_fill = '&nbsp;&nbsp;&nbsp;&nbsp;';
		$text = $left_fill;
		$text .= '<span' . (Clm::$tablet_flg ? ' onClick="return true"':'') . ' class="' . self::$outer_class . (!empty($outer_class) ? ' ' . $outer_class:'') . '">' . "\n" .
				'	' . $value . "\n" .
				'	<span class="' . self::$inner_class . (!empty($inner_class) ? ' ' . $inner_class:'') . '">' . "\n" .
				'		' . (!empty($table_class) ? '<table class="' . $table_class . '"><tr class="' . $table_class . '"><td class="' . $table_class . '">':'') .
				'		' . self::wrap($tip, $wrap) . "\n" .
				'		' . (!empty($table_class) ? '</td></tr></table>':'') .
				'	</span>' . "\n" .
				'</span>' . "\n";
		return $text;
		} // block()
		
} // Cbox_tool_tips

?>
