<?php
	// $Id: sqlite3.php 292 2015-05-18 08:20:03Z robert0609 $
	// Copyright BRAEWORKS (R) 2013

	// sqlite2 wrapper for native sqlite3 class.
	// this file should be removed to future as php-sqlite is fully depreciated

function sqlite_open($location,$mode) {
	$handle = new SQLite3($location);
	return $handle;
	} // sqlite_open()

function sqlite_query($dbhandle,$query) {
//	$array['dbhandle'] = $dbhandle;
//	$array['query'] = $query;
	$result = $dbhandle->query($query);
	return $result;
	} // sqlite_query()

function sqlite_fetch_array(&$result,$type = '') {
//	#Get Columns
//	$i = 0;
//	$cols = $result->numColumns();
//	$columns = array();
//	while($i < $cols) {
//		$columns[ ] = $result->columnName($i);
//		$i++;
//		} // while

	$resx = $result->fetchArray(SQLITE3_ASSOC);
	return $resx;
	} // sqlite_fetch_array()

function sqlite_num_rows(&$result) {
	$cnt = 0;
	while($result->fetchArray()) $cnt++;
	$result->reset();
	return $cnt;
} // sqlite_num_rows()

function sqlite_unbuffered_query($dbhandle, $query) {
	$result = $dbhandle->query($query);
	return $result;
	} // sqlite_unbuffered_query()

function sqlite_current(&$result) {
	$resx = $result->fetchArray(SQLITE3_ASSOC);
	return $resx;
	} //sqlite_current()

function sqlite_next(&$result) {
	// dummy
	} // sqlite_next()

function sqlite_seek(&$result, $row_number) {
	$result->reset();
	$row = 0;
	while($row++ < $row_number) if(!$result->fetchArray()) return false;
	return true;
	} // sqlite_seek()

function sqlite_last_insert_rowid($dbhandle) {
	return $dbhandle->lastInsertRowID();
	} // sqlite_last_insert_rowid()

function sqlite_last_error($dbhandle) {
	return $dbhandle->lastErrorCode();
	} // sqlite_last_error()

function sqlite_error_string($dbhandle) {
	return $dbhandle->lastErrorMsg();
	} // sqlite_error_string()

function sqlite_close($dbhandle) {
	return $dbhandle->close();
	} // sqlite_close()

function sqlite_libversion() {
	$tmp = '__tmp__.sqlite';
	$h = new SQLite3($tmp);
	$v = $h->version();
	$h->close();
	if(file_exists($tmp)) @unlink($tmp);
	return $v['versionString'];
	} // sqlite_libversion()
