<?php
	// $Id: tools.php 224 2015-04-04 04:30:24Z robert0609 $
	// Copyright BRAEWORKS (R) 2013

$tools = Clm::get_tools();
if(count($tools) > 0) {
		Clm::page_start_comment(__FILE__);
?>
<table class="tools_db_container">
<?php if(Clm::is_admin_user()) { ?>
	<tr class="tools_db_container">
		<th class="tools_db_container" title="Tools for users. Tools are hard coded.">Tools:</th>
	</tr>
<?php	} // if ?>
<?php
	$row = 0;
	foreach($tools as $tool) {	// make a table

?>
	<tr class="<?php echo (($row++ & 1) ? 'tools_db_container_odd':'tools_db_container_even'); ?>">
		<td class="tools_db_container">
			<?php
			echo '<a href="' . $tool['url'] . '"' . $tool['new'];
			if(!empty($tool['title'])) echo ' title="' . $tool['title'] . '"';
			echo '>' . $tool['name'] . '</a>';
			?>
		</td>
	</tr>
<?php 	} // foreach ?>
</table>
<?php
	Clm::page_end_comment(__FILE__);
	} // if

