<?php
	// $Id: index.php 401 2016-08-02 13:56:02Z robert0609 $
	// Copyright BRAEWORKS (R) 2013

require_once 'includes/app_top.php';

if(($action != 'login') && (INI_BLIND_LOGIN_BOOL) && (!Clm::is_user_logged_in())) {
	$url = LM_SSL_URL . 'login.php';
	header('Location: ' . $url);
	exit (0);
	} // if

switch($action) {
case 'login':
	if(isset($_SESSION['action'])) unset($_SESSION['action']);
	if(!Clm::$page_info['login_allowed']) {
		$url = LM_WWW_URL . 'index.php';
		header('Location: ' . $url);
		exit (0);
		} // if

	$user_name = '';
	$user_password_md5 = '';
	$user_id = 0;
	if((isset($_GET['user'])) && (!empty($_GET['user']))) {	// admin login from URL
		if((Clm::$cDB->is_table_present('lm_users')) &&
			(!$user_name = Clm::$cDB->get_data_in_table('lm_users','lm_user_name',
				"lm_user_enabled = 1 AND  lm_user_name = '" . $_GET['user'] . "'" .
				(INI_WEBSITE_CLOSED_BOOL ? ' AND lm_user_admin = 1':'')))) {
			// username not found
			$url = LM_WWW_URL . 'index.php';
			header('Location: ' . $url);
			exit (0);
			} //if
		// else username found, fall thru to the login page ($action == 'login')
		} // if
	else if((isset($_POST['user_name'])) &&
		(!empty ($_POST['user_name']))) {

		if((Clm::$cDB->is_table_present('lm_users')) &&
			($user_rows = Clm::$cDB->db_query("SELECT COUNT(*) AS total FROM  lm_users WHERE  lm_user_enabled = 1" .
				(INI_WEBSITE_CLOSED_BOOL ? ' AND lm_user_admin = 1':''))) &&
			($user_rows = Clm::$cDB->db_fetch_array($user_rows)) &&
			($user_rows['total'] > 0)) {
			// have live admins
			$user_name = Clm::$cDB->db_input($_POST['user_name']);

			$sql_query = "SELECT  lm_user_id,lm_user_password_md5,lm_user_admin" .
				" FROM  lm_users" .
				" WHERE  lm_user_enabled = 1 AND  lm_user_name = '" . $user_name . "'" .
				(INI_WEBSITE_CLOSED_BOOL ? ' AND lm_user_admin = 1':'') .
				" LIMIT 1";
			if(($user_ary = Clm::$cDB->db_query($sql_query)) &&
				($user = Clm::$cDB->db_fetch_array($user_ary))) {
				$user_id = $user['lm_user_id'];
				$user_password_md5 = $user['lm_user_password_md5'];
				} // if
			else {
				Clm::addMsg('Username: ' . $user_name . ' not found.');
				// Clm::$cDB->db_error($user_ary);
				} // else
			} // if

		if((!isset($user_id)) || ((int)$user_id == 0)) {
			$url = LM_SSL_URL . 'index.php';
			header('Location: ' . $url);
			exit (0);
			} // if

		if((isset($_POST['user_password'])) &&	// is a login screen
			($user_password_md5 == 'FirstTimeLogin')) {	// first time login
			$_SESSION['lm_user_id'] = $user_id;
			$url = LM_SSL_URL . 'index.php?action=get_password';
			header('Location: ' . $url);
			exit (0);
			} // if

		if((md5($_POST['user_password']) == $user_password_md5)  &&
			(Clm::log_in_user_id($user_id,(((isset($_POST['remember'])) && ($_POST['remember'] == 'on')) ? true:false)))) {
			if(isset($_SESSION['action'])) unset($_SESSION['action']);
			//
			// session_write_close();	// redirect does not save session
			$url = LM_SSL_URL . 'index.php';
			header('Location: ' . $url);
			exit(0);
			} // if
		if(INI_BLIND_LOGIN_BOOL) {
			$_SESSION['BLIND_LOGIN_FAILED'] = 'true';
			Clm::blank_page('<p>User ' . $_SERVER['PHP_AUTH_USER'] . ' login failed.</p>');
			session_regenerate_id();	// stop the re-occurring redirect
			exit(1);
			} // if
		Clm::addMsg('Login failed.');
		} // else if
//	if(INI_BLIND_LOGIN_BOOL) {
//		$url = LM_SSL_URL . 'index.php';
//		header('Location: ' . $url);
//		exit (0);
//		} // if

		break;

case 'set_password':
	if(isset($_SESSION['action'])) unset($_SESSION['action']);
	if(!Clm::$page_info['login_allowed']) {
		$url = LM_WWW_URL . 'index.php';
		header('Location: ' . $url);
		exit (0);
		} // if
	$user_name = '';
	$user_password_md5 = '';
	$user_id = 0;
	if((isset($_POST['user_name'])) &&
		(!empty ($_POST['user_name']))) {

		$user_name = Clm::$cDB->db_input($_POST['user_name']);

		$sql_query = "SELECT  lm_user_id,lm_user_password_md5,lm_user_admin" .
			" FROM  lm_users" .
			" WHERE  lm_user_enabled = 1 AND  lm_user_name = '" . $user_name . "'" .
			(INI_WEBSITE_CLOSED_BOOL ? ' AND lm_user_admin = 1':'') .
			" LIMIT 1";
		if(($user_ary = Clm::$cDB->db_query($sql_query)) &&
			($user = Clm::$cDB->db_fetch_array($user_ary))) {
			$user_id = $user['lm_user_id'];
			$user_password_md5 = $user['lm_user_password_md5'];
			} // if
		else {
			Clm::addMsg('Username: ' . $user_name . ' not found.');
			// Clm::$cDB->db_error($user_ary);
			} // else

		if((isset($_POST['user_password'])) &&
			($user_password_md5 == 'FirstTimeLogin')) {
			if(isset($_SESSION['action'])) unset($_SESSION['action']);
			$lm_user_password = html_entity_decode($_POST['user_password']);
			$lm_user_confirm = html_entity_decode($_POST['user_confirm']);
			if(strlen($lm_user_password) < 4) {
				Clm::addMsg('Password too short.');
				} // else if
			else if($lm_user_password != $lm_user_confirm) {
				Clm::addMsg('Password/confirm error.');
				} // if
			else {
				$fields = array();
				$fields['lm_user_password_md5'] = md5($lm_user_password);
				if(Clm::$cDB->db_perform('lm_users',$fields,'update',"lm_user_id = " . (int)$user_id . "")) {
					Clm::addMsg('Set 1st password for ' . $user_name . ".",'info');
					Clm::$cDB->logEvent('Set 1st password for ' . $user_name . ".");
					Clm::log_in_user_id($user_id,false);
					if(isset($_SESSION['action'])) unset($_SESSION['action']);
					$url = LM_SSL_URL . 'index.php';
					header('Location: ' . $url);
					exit (0);
					} // if
				} // if
			} // if
		Clm::addMsg('Set 1st password failed.');
		} // else
	break;
case 'about_lm':
case 'lm_manual':
	if(INI_ALLOW_ABOUT_MANUAL_LINKS_BOOL) break;
	if(!Clm::is_user_logged_in()) {
		if(isset($_SESSION['action'])) unset($_SESSION['action']);
		$url = LM_SSL_URL . 'index.php';
		header('Location: ' . $url);
		exit (0);
		} // if
	break;
case 'rebuild_setup':
	if(Clm::is_admin_user()) {
		if((Clm::do_lm_warnings(true)) &&
			(Clm::$cDB->checkDBversion(true))) { // rebuild setup
			Clm::addMsg('Setup rebuild complete.','success');
			} // if
		else Clm::addMsg('Failed to rebuild setup.','error');
		} // if
	else Clm::addMsg('Must be an administrator to rebuild setup.','error');
	Clm::saveMsgs();
	if(isset($_SESSION['action'])) unset($_SESSION['action']);
	$url = LM_SSL_URL . 'index.php';
	header('Location: ' . $url);
	exit (0);
	break;
case 'log_view':
	if(!Clm::is_admin_user()) {
		Clm::addMsg('Must be an administrator to view logs.','error');
		Clm::saveMsgs();
		if(isset($_SESSION['action'])) unset($_SESSION['action']);
		$url = LM_SSL_URL . 'index.php';
		header('Location: ' . $url);
		exit (0);
		} // if
	break;

default:
	break;
	} // switch

?>
<!DOCTYPE html>
<html dir="ltr" lang="<?php echo INI_LANGUAGE_CODE; ?>">
<?php Clm::page_start_comment(__FILE__); ?>
<?php Clm::output_head(); ?>
	<body>
		<script type="text/javascript">
		if(self != top) {
			try {
				if (document.domain != top.document.domain) {
					throw "Security violation - possible click jacking.";
					/* should never get here under secure circumstances */
					} // if
				// else its ok
				} // try
			catch (e) {
					// self.location = "<?php echo Clm::$page_info['base_ref']; ?>index.php";
					top.location = "<?php echo Clm::$page_info['base_ref']; ?>index.php"
					} // catch
				} // if

		function checkBackMirroring(obj) {
			// check that an index regression (eg clicking parent directory in index page)
			// can cause iframe mirroring
			try {	// IE has some problems here
				var lm_base = '<?php echo ((isset($_SERVER['HTTPS']) && ($_SERVER['HTTPS'] == 'on')) ? LM_SSL_URL : LM_WWW_URL); ?>';
				var href = obj.contentDocument.location.href;
				if((href) && (href == lm_base)) {
					var back = obj.contentDocument.referrer;
					obj.src = back;	// go back
					return true;
					} // if
				return false;
				} // try
			catch (e) {
				// IE obj.contentWindow.location.href (!!!)
				return false;
				} // catch
			return false;
			} // checkBackMirroring()
		</script>
		<noscript></noscript>

<?php if(Clm::$block_html) { ?>

		<div id="container">
			<?php include 'includes/app_page_header.php'; ?>
			<?php include 'includes/app_page_left_column.php'; ?>
			<script type="text/javascript">
				function onloadIframe(obj) { // here when loads initially and on every iframe reload in block style
					if(checkBackMirroring(obj)) return;

					var link_frame = document.getElementById('<?php echo (Clm::$left_column ? 'link_frame_wlc':'link_frame_nolc'); ?>');
					obj.style.height = link_frame.offsetHeight;
					} // onloadIframe()
			</script>
			<noscript></noscript>
			<?php include 'includes/app_page_body.php'; ?>
			<?php include 'includes/app_page_footer.php'; ?>
		</div>

<?php	} else { ?>

		<table>
			<?php if(Clm::is_browser_html5()) echo '<caption>The web page</caption>'; ?>
			<tr>
				<td>
					<?php include 'includes/app_page_header.php'; ?>
				</td>
			</tr>
			<tr>
				<td>
					<table>
						<?php if(Clm::is_browser_html5()) echo '<caption>Page body</caption>'; ?>
						<tr>
<?php	if(Clm::$left_column) { ?>
							<td width="<?php echo INI_LEFT_WIDTH; ?>" valign="top">
								<?php include 'includes/app_page_left_column.php'; ?>
							</td>
<?php		} // if ?>
							<td>
							<td valign="top">
								<script type="text/javascript">
									function onloadIframe(obj) { // here when loads initially and on every iframe reload in inline style
										if(checkBackMirroring(obj)) return;

										// check drop back for updates at a smaller height
										var height_min = 250;	// about right
										var height = obj.contentWindow.document.body.scrollHeight;
										if(height > height_min) {
											// bring back the scroll height
											obj.height = height_min;
											this.height = height_min;
											} // if

										// scrollheight now adjusted - step 1
										obj.height = (height + 10);	// + 50 for IE 5.5
//										height = obj.clientHeight;
//										if(height < obj.contentWindow.document.body.scrollHeight) {	// been re-calc'd
//											// scrollheight now re-adjusted - step 2
//											// this happens when apache indexed pages (html 3.2) output the > char as a line truncation
//											obj.height = (obj.contentWindow.document.body.scrollHeight + 10);	// + 50 for IE 5.5
//											} // if
										} // onloadIframe()
								</script>
								<noscript></noscript>
								<?php include 'includes/app_page_body.php'; ?>
							</td>
						</tr>
					</table>
				</td>
			</tr>
			<tr>
				<td>
				<?php include 'includes/app_page_footer.php'; ?>
				</td>
			</tr>
		</table>

<?php	} // else ?>

<?php if(Clm::$tooltips_flg) { ?>
	<script type="text/javascript">
		window.ready=titles2tooltips(<?php echo (Clm::$tablet_flg ? 'true':'false'); ?>);
	</script>
<?php	} // if ?>

<?php Clm::page_end_comment(__FILE__); ?>
<?php Clm::do_google_analytics(); ?>
	</body>
</html>
<?php
require_once 'includes/app_bottom.php';

