<?php
	// $Id: edit_config.php 390 2016-04-27 13:48:39Z robert0609 $
	// Copyright BRAEWORKS (R) 2013

$cLMC = new Clmc();

$lm_config_id = 0;
$lm_config_op = '';
if($action == 'edit_config') { // a bit of caution
	if(((isset($_POST['edit'])) && (isset($_POST['config_edit_id']))) ||
		((isset($_GET['config_edit_id'])) && ((int)$_GET['config_edit_id'] > 0))) {
		$lm_config_op = 'edit';
		if(isset($_POST['config_edit_id'])) $lm_config_id = (int)$_POST['config_edit_id'];
		else if(isset($_GET['config_edit_id'])) $lm_config_id = (int)$_GET['config_edit_id'];
		else { // what??
			$lm_config_op = '';
			$lm_config_id = 0;
			} // else

		$sql_query = "SELECT  lm_config_name, lm_config_value,lm_config_description, lm_config_key, lm_config_allowed_values" .
			", lm_config_show_func, lm_config_input_func, lm_config_save_func" .
			", DATETIME(lm_config_added, 'LocalTime') as  lm_config_added" .
			", DATETIME(lm_config_updated, 'LocalTime') as  lm_config_updated" .
			" FROM  lm_configs WHERE  lm_config_id = '" . (int)$lm_config_id . "'";
		if(($result = Clm::$cDB->db_query($sql_query)) &&
			(Clm::$cDB->db_num_rows($result) > 0) &&
			($config = Clm::$cDB->db_fetch_array($result))) {
			foreach($config as $c => $v) $$c = $v;
			Clm::$cDB->db_free_result($result);
			} // if
		} // if
	else if((isset($_POST['save'])) && (isset($_POST['lm_config_id']))) {
		$lm_config_op = 'save';
		$lm_config_id = (int)$_POST['lm_config_id'];
		$lm_config_name = html_entity_decode($_POST['lm_config_name']);
		$method = Clm::$cDB->get_data_in_table('lm_configs','lm_config_save_func',"lm_config_id = '" . (int)$lm_config_id . "'");
		if((!empty($method)) &&
			(method_exists($cLMC,$method))) {
			$lm_config_old_value = Clm::$cDB->get_data_in_table('lm_configs','lm_config_value',"lm_config_id = '" . (int)$lm_config_id . "'");
			$lm_config_value = $cLMC->$method('lm_config_value',$lm_config_old_value);
			} // if
		else $lm_config_value = html_entity_decode($_POST['lm_config_value']);

		if(!$cLMC->is_config_value_ok($lm_config_id,$lm_config_value)) {
			Clm::addMsg('Value not allowed');
			// reget values
			$sql_query = "SELECT  lm_config_name, lm_config_description, lm_config_key" .
				", lm_config_show_func" .
				", DATETIME(lm_config_added, 'LocalTime') as  lm_config_added" .
				", DATETIME(lm_config_updated, 'LocalTime') as  lm_config_updated" .
				" FROM  lm_configs WHERE  lm_config_id = '" . (int)$lm_config_id . "'";
			if(($result = Clm::$cDB->db_query($sql_query)) &&
				(Clm::$cDB->db_num_rows($result) > 0) &&
				($config = Clm::$cDB->db_fetch_array($result))) {
				foreach($config as $c => $v) $$c = $v;
				Clm::$cDB->db_free_result($result);
				} // if
			} // if
		else {	// update it
			$fields = array();
			$fields['lm_config_value'] = $lm_config_value;
			if(!Clm::$cDB->db_perform('lm_configs',$fields,'update',"lm_config_id = '" . (int)$lm_config_id . "'")) {
				Clm::addMsg('Config update, ' . $lm_config_name . " failed");
				Clm::$cDB->logEvent('ERROR: config update, ' . $lm_config_name);
				} // if
			else {
				unset($_SESSION['lm_config_id']);
				Clm::addMsg('Saved configuration values in database.','success');
				} // else
			// $lm_config_id = 0;
			$lm_config_op = '';
			} // if
		} // else if
	else if((INI_ALLOW_TABLE_RELOAD_BOOL) && (isset($_POST['reloadDB']))) {
		$lm_config_op = 'reloadDB';
		$lm_config_id = 0;
		} // else if
	else if(isset($_POST['checkDB'])) {
		$lm_config_op = 'checkDB';
		$lm_config_id = 0;
		} // else if
	else if(isset($_POST['cancel'])) {
		$lm_config_op = 'cancel';
		$lm_config_id = 0;
		} // else if
	} // if
?>

<?php Clm::page_start_comment(__FILE__); ?>

<table class="page_container"><tr class="page_container"><td class="page_container">
<table class="page_config">
	<tr class="page_config">
		<th class="page_config" style="text-align: left">

			<?php echo Clm::get_admin_scroll2top_anchor(false); ?>

			<h1>Configuration Values</h1>
		</th>
	</tr>
	<?php if($lm_config_op == 'reloadDB') { ?>
	<tr class="page_config">
		<td class="page_config" valign="bottom">
			Reloading Configuration Table in Database
			<?php Clm::$cDB->installDatabase('lm_configs',true ,true); ?>
		</td>
	</tr>
	<tr class="page_config"><td class="page_config">&nbsp;</td></tr>
	<?php } // if ?>
	<?php if($lm_config_op == 'checkDB') { ?>
	<tr class="page_config">
		<td class="page_config" valign="bottom">
			Checking Configuration Table in Database
			<?php Clm::$cDB->installDatabase('lm_configs',false ,false); ?>
		</td>
	</tr>
	<tr class="page_config"><td class="page_config">&nbsp;</td></tr>
	<?php } // if ?>
	<?php if(Clm::getMsgsCount()) { ?>
	<tr class="page_config_msgs">
		<td class="page_config_msgs">
			<?php echo Clm::getMsgs(); ?>
		</td>
	</tr>
	<tr class="page_config"><td class="page_config">&nbsp;</td></tr>
	<?php } //if ?>
	<form method="post" name="edit_config" action="<?php echo $_SERVER['PHP_SELF'] . '?action=edit_config'; ?>" method="post" enctype="multipart/form-data">
	<?php if(isset($_GET['keywords'])) echo '<input type="hidden" name="search" value="' . $_GET['keywords'] . '"/>'; ?>
	<tr class="page_config">
		<td class="page_config" valign="bottom">
			Select config name:&nbsp;
			<select name="config_edit_id" size="1">
				<?php
					$sql_query = "SELECT lm_config_id,lm_config_name,lm_config_value" .
									" FROM  lm_configs" .
									" WHERE LENGTH(lm_config_name) > 0" .
									" ORDER BY  lm_config_name";
					$cnt = 0;
					if(($result = Clm::$cDB->db_query($sql_query)) &&
						(($cnt = Clm::$cDB->db_num_rows($result)) > 0)) {
						while($config = Clm::$cDB->db_fetch_array($result)) {
//							if(empty($config['lm_config_name'])) continue;
							echo '<option value="' . $config['lm_config_id'] .'"'. ((int)$config['lm_config_id'] == $lm_config_id ? 'SELECTED':'') . '>' . $config['lm_config_name'] . ((int)$config['lm_config_id'] == $lm_config_id ? ' **':'') . '</option>' . "\n";
							} // while
						} // if
					else echo '<option value="0">(No configs setup)</option>' . "\n";
				?>
			</select>
			&nbsp;&nbsp;
			<button name="edit" value="edit" type="submit">Edit</button>
			&nbsp;&nbsp;
			<button name="checkDB" value="checkDB" type="submit" title="Check configuration table in database for missing entries." onClick="return confirm('Check and refresh configuration table in database?')">Check</button>
			<?php if(INI_ALLOW_TABLE_RELOAD_BOOL) { ?>
			&nbsp;&nbsp;
			<button name="reloadDB" value="reloadDB" type="submit" title="Clear and re-initialise configuration table in database." onClick="return confirm('Clear and re-initialise configuration table in database?')">Reload</button>
			<?php	} // if ?>
			<?php Clm_search::get_form_return_link(); ?>
		</td>
	</tr>
	<tr class="page_config"><td class="page_config">&nbsp;</td></tr>

	<?php
	if((($lm_config_op == 'edit') || ($lm_config_op == 'save')) &&
		(isset($lm_config_id)) && ($lm_config_id > 0)) {
	?>
	<tr class="page_config">
		<th class="page_config">
			Edit Configuration Value - <?php echo $lm_config_name; ?>
			&nbsp;&nbsp;
			<span class="page_config">(
				Added:&nbsp;<?php echo $lm_config_added;?>
				&nbsp;&nbsp;
				Updated:&nbsp;<?php echo $lm_config_updated;?>
			)</span>
<?php
			if((isset($_GET['name'])) && ($_GET['name'] == $lm_config_key))
				echo '&nbsp;&nbsp;<span class="msg_success"><img src="images/success.gif">Found here</span>' .
					'&nbsp;&nbsp;<a href="index.php?action=edit_search&search=' . $_GET['keywords'] . '" title="Search for:' . urldecode ($_GET['keywords']) . '">Return to search.</a>';
?>
		</th>
	</tr>
	<input type="hidden" name="lm_config_id" value="<?php echo $lm_config_id; ?>"/>
	<input type="hidden" name="lm_config_name" value="<?php echo htmlentities($lm_config_name); ?>"/>
	<tr class="page_config">
		<td class="page_config" style="text-align: left">
			<table class="page_config">
				<tr class="page_config">
					<td class="page_config" style="text-align: left">Description:</td>
					<td class="page_config" style="text-align: left"><i><?php echo $lm_config_description; ?></i></td>
				</tr>
				<tr class="page_config">
					<td class="page_config" style="text-align: left">Value:</td>
					<td class="page_config" style="text-align: left"><?php echo $cLMC->show_value($lm_config_value,$lm_config_allowed_values,$lm_config_input_func,$lm_config_description); ?></td>
				</tr>
<?php			if(INI_DEBUG_BOOL) { ?>
				<tr class="page_config">
					<td class="page_config" style="text-align: left">Code Key:</td>
					<td class="page_config" style="text-align: left"><i><?php echo $lm_config_key; ?></i></td>
				</tr>
<?php				} // if ?>
			</table>
		</td>
	</tr>
	<tr class="page_config">
		<td class="page_config" style="text-align: right">
			<button name="save" value="save" type="submit">Save</button>
			&nbsp;&nbsp;
			<button name="cancel" value="cancel" type="submit">Cancel</button>
		</td>
	</tr>
	</form>
	<?php } // if  ?>
	<tr class="page_config">
		<td class="page_config" style="text-align: left">
			<table class="page_config">
				<tr class="page_config">
					<th width="175x" class="page_config">Name</th>
					<!--<th width="200px" class="page_config" title="Constant value used in php code">Code Key</th>-->
					<th width="150px" class="page_config">Value</th>
					<th class="page_config">Description</th>
				</tr>
	<?php
		$sql_query = "SELECT  lm_config_id,lm_config_name,lm_config_value,lm_config_description,lm_config_key,lm_config_show_func" .
			" FROM  lm_configs WHERE LENGTH(lm_config_name) > 0 ORDER BY  lm_config_name,lm_config_id";
		if(($result = Clm::$cDB->db_query($sql_query)) &&
			(Clm::$cDB->db_num_rows($result) > 0)) {
			$row = 0;
			while($config = Clm::$cDB->db_fetch_array($result)) {
				echo '<tr class="' . (($row & 1) ? 'page_config_odd':'page_config_even') . '">';
				echo '<td class="page_config" style="text-align: left" valign="top">';
				echo '<a href="index.php?action=edit_config&config_edit_id=' . $config['lm_config_id'] . '" title="' . strip_tags($config['lm_config_description']) . '">' . $config['lm_config_name'] . '</a>';
				echo '</td>';
				echo '<!--<td class="page_config" style="text-align: left">' . $config['lm_config_key'] . '</td>-->';
				echo '<td class="page_config" style="text-align: left">';
					if((!empty($config['lm_config_show_func'])) &&
						(method_exists($cLMC,$config['lm_config_show_func']))) {
						$method = $config['lm_config_show_func'];
						echo $cLMC->$method($config['lm_config_value']);
						} // if
					else if(!empty($config['lm_config_allowed_values'])) echo Clm::make_nice_name ($config['lm_config_value']);
					else echo $config['lm_config_value'];
				echo '</td>';
				echo '<td class="page_config" style="text-align: left">' . $config['lm_config_description'] . '</td>';
				echo '</tr>' . "\n";
				$row++;
				} // while
			Clm::$cDB->db_free_result($result);
			} // if
		else echo '<tr class="page_config"><td class="page_config" style="text-align: left">(No configs setup)</td></tr>' . "\n";
		?>
			</table>
		</td>
	</tr>
	<?php if(Clm::getMsgsCount()) { ?>
	<tr class="page_config_msgs">
		<td class="page_config_msgs">
			<?php echo Clm::getMsgs(); ?>
		</td>
	</tr>
	<?php } //if ?>
</table>
</td></tr></table>


<?php Clm::page_end_comment(__FILE__); ?>
