<?php
	// $Id: edit_tools.php 415 2016-10-16 05:48:04Z robert0609 $
	// Copyright BRAEWORKS (R) 2013


$lm_tool_id = 0;
$lm_tool_op = '';
if($action == 'edit_tools') { // a bit of caution
	if(((isset($_POST['edit'])) && (isset($_POST['tool_edit_id'])) && ((int)$_POST['tool_edit_id'] > 0)) ||
		((isset($_GET['tool_edit_id'])) && ((int)$_GET['tool_edit_id'] > 0))) {
		$lm_tool_op = 'edit';

		if(isset($_POST['tool_edit_id'])) $lm_tool_id = (int)$_POST['tool_edit_id'];
		else if(isset($_GET['tool_edit_id'])) $lm_tool_id = (int)$_GET['tool_edit_id'];
		else { // what??
			$lm_tool_op = '';
			$lm_tool_id = 0;
			} // else

		$sql_query = "SELECT  lm_tool_name,lm_tool_url, lm_tool_order" .
			", lm_tool_name , lm_tool_description, lm_tool_title" .
			", lm_tool_new_page, lm_tool_enabled, lm_tool_ssl, lm_tool_add_name2url, lm_tool_group_ids" .
			", DATETIME(lm_tool_added, 'LocalTime') as  lm_tool_added" .
			", DATETIME(lm_tool_updated, 'LocalTime') as  lm_tool_updated" .
			" FROM  lm_tools WHERE  lm_tool_id = '" . (int)$lm_tool_id . "'";
		if(($result = Clm::$cDB->db_query($sql_query)) &&
			(Clm::$cDB->db_num_rows($result) > 0) &&
			($tool = Clm::$cDB->db_fetch_array($result))) {
			$lm_tool_name = $tool['lm_tool_name'];
			$lm_tool_url = $tool['lm_tool_url'];
			$lm_tool_description = $tool['lm_tool_description'];
			$lm_tool_title = $tool['lm_tool_title'];
			$lm_tool_order = $tool['lm_tool_order'];
			$lm_tool_ssl = $tool['lm_tool_ssl'];
			$lm_tool_new_page = $tool['lm_tool_new_page'];
			$lm_tool_add_name2url = $tool['lm_tool_add_name2url'];
			$lm_tool_group_ids = $tool['lm_tool_group_ids'];
			$lm_tool_enabled = $tool['lm_tool_enabled'];
			$lm_tool_added = $tool['lm_tool_added'];
			$lm_tool_updated = $tool['lm_tool_updated'];
			Clm::$cDB->db_free_result($result);
			} // if
		else { // not found
			$lm_tool_id = 0;
			$lm_tool_op = '';
			$lm_tool_added = '';
			$lm_tool_updated = '';
			} // else
		} // if
	else if((isset($_POST['delete'])) &&
		((isset($_POST['tool_edit_id'])) || (isset($_POST['lm_tool_id'])))) {
		$lm_tool_op = 'delete';
		$lm_tool_id = (int)(isset($_POST['lm_tool_id']) ? $_POST['lm_tool_id']:$_POST['tool_edit_id']);

		$sql_query = "SELECT  lm_tool_name,lm_tool_enabled" .
					" FROM  lm_tools WHERE  lm_tool_id = '" . (int)$lm_tool_id . "'";
		if(($result = Clm::$cDB->db_query($sql_query)) &&
			(Clm::$cDB->db_num_rows($result) > 0) &&
			($tool = Clm::$cDB->db_fetch_array($result))) {
			$lm_tool_name = $tool['lm_tool_name'];
			$lm_tool_enabled = $tool['lm_tool_enabled'];
			} // if
		} // else if
	else if((isset($_POST['confirm_delete'])) && (isset($_POST['lm_tool_id']))) {
		$lm_tool_op = 'confirm_delete';
		$lm_tool_id = (int)$_POST['lm_tool_id'];

		$sql_query = "DELETE FROM  lm_tools WHERE  lm_tool_id = '" . (int)$lm_tool_id . "'";
		Clm::$cDB->db_query($sql_query);
		new Clm_xml_sitemap();	// do sitemap
		$lm_tool_id = 0;
		} // else if
	else if(isset($_POST['add'])) {
		$cols = Clm::$cDB->get_columns_list('lm_tools',true);
		foreach($cols as $c => $v) $$c = $v;
		$lm_tool_op = 'add';
		$lm_tool_id = 0;
		} // else if
	else if((isset($_POST['insert'])) && (isset($_POST['lm_tool_id']))) {
		$lm_tool_op = 'insert';
		} // else if
	else if((isset($_POST['save'])) && (isset($_POST['lm_tool_id']))) {
		$lm_tool_op = 'save';
		} // else if
	else if((INI_ALLOW_TABLE_RELOAD_BOOL) && (isset($_POST['reloadDB']))) {
		$lm_tool_op = 'reloadDB';
		$lm_tool_id = 0;
		} // else if
	else if(isset($_POST['cancel'])) {
		$lm_tool_op = 'cancel';
		$lm_tool_id = 0;
		} // else if

	if(($lm_tool_op == 'save') || ($lm_tool_op == 'insert')) {
		// do it once
		$lm_tool_id = (int)$_POST['lm_tool_id'];
		$lm_tool_url = rawurldecode($_POST['lm_tool_url']);
		$lm_tool_name = html_entity_decode($_POST['lm_tool_name']);
		$lm_tool_description = html_entity_decode($_POST['lm_tool_description']);
		$lm_tool_title = html_entity_decode($_POST['lm_tool_title']);
		$lm_tool_order = (int)$_POST['lm_tool_order'];
		$lm_tool_group_ids = implode(':',$_POST['lm_tool_group_ids']);
		$lm_tool_enabled = (isset($_POST['lm_tool_enabled']) ? 1:0);
		$lm_tool_ssl = (isset($_POST['lm_tool_ssl']) ? 1:0);
		$lm_tool_new_page = (isset($_POST['lm_tool_new_page']) ? 1:0);
		$lm_tool_add_name2url = (isset($_POST['lm_tool_add_name2url']) ? 1:0);
		$lm_tool_added = html_entity_decode($_POST['lm_tool_added']);
		$lm_tool_updated = html_entity_decode($_POST['lm_tool_updated']);
		if((empty($lm_tool_name)) || (strlen($lm_tool_name) < 4)) {
			Clm::addMsg('Name too short.');
			} // if
		else if(Clm::is_tool_name_inuse($lm_tool_name,
			(((int)$lm_tool_id > 0) ? Clm::$cDB->get_data_in_table('lm_tools','lm_tool_name','lm_tool_id = ' . (int)$lm_tool_id):''))) {
			Clm::addMsg('Name already in use.');
			} // else if
		if((empty($lm_tool_url)) || (strlen($lm_tool_url) < 4)) {
			Clm::addMsg('URL too short.');
			} // if
		if(!Clm::getMsgsCount('error')) {	// update it
			$fields = array();
			$fields['lm_tool_name'] = $lm_tool_name;
			$fields['lm_tool_url'] = $lm_tool_url;
			$fields['lm_tool_description'] = $lm_tool_description;
			$fields['lm_tool_title'] = $lm_tool_title;
			$fields['lm_tool_order'] = $lm_tool_order;
			$fields['lm_tool_group_ids'] = $lm_tool_group_ids;
			$fields['lm_tool_enabled'] = $lm_tool_enabled;
			$fields['lm_tool_ssl'] = $lm_tool_ssl;
			$fields['lm_tool_new_page'] = $lm_tool_new_page;
			$fields['lm_tool_add_name2url'] = $lm_tool_add_name2url;
			if(($lm_tool_op == 'insert') &&
				(!Clm::$cDB->db_perform('lm_tools',$fields,'insert',''))) {
				Clm::addMsg('Tool insert, ' . $lm_tool_name . " failed");
				Clm::$cDB->logEvent('ERROR: tool insert, ' . $lm_tool_name);
				} // if
			else if(($lm_tool_op == 'save') &&
				(!Clm::$cDB->db_perform('lm_tools',$fields,'update',"lm_tool_id = " . (int)$lm_tool_id . ""))) {
				Clm::addMsg('Tool update, ' . $lm_tool_name . " failed");
				Clm::$cDB->logEvent('ERROR: tool update, ' . $lm_tool_name);
				} // if
			else {
				unset($_SESSION['lm_tool_id']);
				Clm::addMsg('Saved tool config.','success');
				} // else
			new Clm_xml_sitemap();	// do sitemap
			$lm_tool_id = 0;
			$lm_tool_op = '';
			} // if

		} // if
	} // if
$cnt = Clm::$cDB->get_row_count_in_table('lm_tools');
?>

<?php Clm::page_start_comment(__FILE__); ?>

<table class="page_container"><tr class="page_container"><td class="page_container">
<table class="page_config">
	<tr class="page_config">
		<th class="page_config">

			<?php echo Clm::get_admin_scroll2top_anchor(false); ?>

			<h1>Tools Config</h1>
		</th>
	</tr>
	<?php if($lm_tool_op == 'reloadDB') { ?>
	<tr class="page_config">
		<td class="page_config" valign="bottom">
			<?php Clm::$cDB->installDatabase('lm_tools',true ,true); ?>
		</td>
	</tr>
	<tr class="page_config"><td class="page_config">&nbsp;</td></tr>
	<?php } // if ?>
	<?php if(Clm::getMsgsCount()) { ?>
	<tr class="page_config_msgs">
		<td class="page_config_msgs">
			<?php echo Clm::getMsgs(); ?>
		</td>
	</tr>
	<?php } //if ?>
	<form method="post" name="edit_tool" action="<?php echo $_SERVER['PHP_SELF'] . '?action=edit_tools'; ?>" method="post" enctype="multipart/form-data">
	<?php if(isset($_GET['keywords'])) echo '<input type="hidden" name="search" value="' . $_GET['keywords'] . '"/>'; ?>
	<tr class="page_config">
		<td class="page_config" valign="bottom">
			Select tool name:&nbsp;
			<?php echo  Clm::gen_tool_selection_list('tool_edit_id',$lm_tool_id,'size="1"'); ?>
			<?php if($cnt > 0) { ?>
			&nbsp;&nbsp;
			<button name="edit" value="edit" type="submit">Edit</button>
			&nbsp;&nbsp;
			<button name="delete" value="delete" type="submit">Delete</button>
			<?php	} //if ?>
			&nbsp;&nbsp;
			<button name="add" value="add" type="submit">Add</button>
			<?php if(INI_ALLOW_TABLE_RELOAD_BOOL) { ?>
			&nbsp;&nbsp;
			<button name="reloadDB" value="reloadDB" type="submit" title="Clear and re-initialise tools table in database." onClick="return confirm('Clear and re-initialise tools table in database?')">Reload</button>
			<?php	} // if ?>
			<?php Clm_search::get_form_return_link(); ?>
		</td>
	</tr>

	<?php
	if((($lm_tool_op == 'edit') || ($lm_tool_op == 'save') ||
		($lm_tool_op == 'add') || ($lm_tool_op == 'insert')) &&
		(isset($lm_tool_id))) {
	?>
	<tr class="page_config"><td class="page_config">&nbsp;</td></tr>
	<tr class="page_config">
		<th class="page_config">
			<?php if($lm_tool_id == 0) {
				echo 'Add Tool';
				} // if
			else {
				echo 'Edit Tool' .
					'&nbsp;&nbsp;<span class="page_config">(Added:&nbsp;' . $lm_tool_added .
					'&nbsp;&nbsp;Updated:&nbsp;' . $lm_tool_updated . ')</span>';
				if((isset($_GET['name'])) && ($_GET['name'] == $lm_tool_name))
					echo '&nbsp;&nbsp;<span class="msg_success"><img src="images/success.gif">Found here</span>' .
						'&nbsp;&nbsp;<a href="index.php?action=edit_search&search=' . $_GET['keywords'] . '" title="Search for:' . urldecode ($_GET['keywords']) . '">Return to search.</a>';
				} // else
			?>
		</th>
	</tr>
	<input type="hidden" name="lm_tool_id" value="<?php echo $lm_tool_id; ?>"/>
	<input type="hidden" name="lm_tool_name_old" value="<?php echo htmlentities($lm_tool_name); ?>"/>
	<input type="hidden" name="lm_tool_added" value="<?php echo htmlentities($lm_tool_added); ?>"/>
	<input type="hidden" name="lm_tool_updated" value="<?php echo htmlentities($lm_tool_updated); ?>"/>
	<tr>
		<td>
			<table class="page_config">
				<tr>
					<td width ="100px" class="page_config" valign="top">Select group/s:</td>
					<td class="page_config">
						<?php echo  Clm::gen_group_selection_list('lm_tool_group_ids[]',$lm_tool_group_ids,10, 'multiple'); ?>
					</td>
				</tr>
				<tr>
					<td width ="100px" class="page_config">Name:</td>
					<td class="page_config">
						<input type="text" name="lm_tool_name" size="40" value="<?php echo $lm_tool_name; ?>" title="Unique tool name. Appears on page as a tool heading. Minimum of 4 charaters" autocapitalize="off"/>
					</td>
				</tr>
				<tr>
					<td width ="100px" class="page_config">Tool URL:</td>
					<td class="page_config">
						<?php $option_cnt = 0; echo  Clm::get_tools_dir_selection('lm_tool_url',$lm_tool_url,$option_cnt); ?>
					</td>
				</tr>
				<tr>
					<td class="page_config">Description:</td>
					<td class="page_config">
						<input type="text" name="lm_tool_description" size="80" value="<?php echo $lm_tool_description; ?>" title="Tool description (optional), an admin note." autocapitalize="off"/>
					</td>
				</tr>
				<tr>
					<td class="page_config">Title:</td>
					<td class="page_config">
						<input type="text" name="lm_tool_title" size="80" value="<?php echo $lm_tool_title; ?>" title="Tool title (optional), appears when mouse is hovered over tool name." autocapitalize="off"/>
					</td>
				</tr>
				<tr>
					<td class="page_config">Display Order:</td>
					<td class="page_config">
						<input type="text" name="lm_tool_order" size="5" value="<?php echo $lm_tool_order; ?>" title="Sorting order of tool. Used to control the order of the tool in this section. Low numbers at the top of the page, ascending down the page." autocapitalize="off"/>
					</td>
				</tr>
				<tr>
					<td class="page_config">SSL:</td>
					<td class="page_config">
						<input type="checkbox" name="lm_tool_ssl"<?php echo ($lm_tool_ssl == 1 ? ' CHECKED':'');?> title="Check to open URL using SSL encrytion, uncheck to use the default"/>
					</td>
				</tr>
				<tr>
					<td class="page_config">New Tab:</td>
					<td class="page_config">
						<input type="checkbox" name="lm_tool_new_page"<?php echo ($lm_tool_new_page == 1 ? ' CHECKED':'');?> title="Check to open URL in a new browser tab or window, uncheck to disable new tab or window.&#10;NOTE: If the local tool produces a frame set, it should be shown on a new tab."/>
					</td>
				</tr>
				<tr>
					<td class="page_config">Add Name to URL:</td>
					<td class="page_config">
						<input type="checkbox" name="lm_tool_add_name2url"<?php echo ($lm_tool_add_name2url == 1 ? ' CHECKED':'');?> title="Check to add tool name to URL."/>
					</td>
				</tr>
				<tr>
					<td class="page_config">Enabled:</td>
					<td class="page_config">
						<input type="checkbox" name="lm_tool_enabled"<?php echo ($lm_tool_enabled == 1 ? ' CHECKED':'');?> title="Check to enable tool, uncheck to disable tool"/>
					</td>
				</tr>
			</table>
		</td>
	</tr>

	<tr class="page_config">
		<td class="page_config" style="text-align: right">
			<?php if($lm_tool_id == 0) { ?>
			<button name="insert" value="insert" type="submit">Insert</button>
			<?php } else { ?>
			<button name="save" value="save" type="submit">Save</button>
			<?php	} // else ?>
			&nbsp;&nbsp;
			<button name="cancel" value="cancel" type="submit">Cancel</button>
		</td>
	</tr>

	<?php } else if(($lm_tool_op == 'delete') && (isset($lm_tool_id)) && ($lm_tool_id > 0)) { ?>
	<tr class="page_config"><td class="page_config">&nbsp;</td></tr>
	<tr class="page_config"><th class="page_config">Delete Tool - <?php echo $lm_tool_name; ?></th></tr>
	<input type="hidden" name="lm_tool_id" value="<?php echo $lm_tool_id; ?>"/>
	<input type="hidden" name="lm_tool_name" value="<?php echo htmlentities($lm_tool_name); ?>"/>
	<tr class="page_config">
		<td class="page_config">
			Please confirm.
			&nbsp;&nbsp;
			<button name="confirm_delete" value="confirm_delete" type="submit">Confirm Delete</button>
			&nbsp;&nbsp;
			<button name="cancel" value="cancel" type="submit">Cancel</button>
		</td>
	</tr>
	<?php }  ?>
	</form>
	<tr class="page_config"><th class="page_config">Summary</th></tr>
	<tr class="page_config">
		<td class="page_config" style="text-align: left">
			<table class="page_config">
				<tr class="page_config">
					<th width="150px" class="page_config">Name</th>
					<th width="70px" class="page_config" title="Display order">Order</th>
					<th width="70px" class="page_config">Enabled</th>
					<th width="40px" class="page_config" title="Use SSL encryption">SSL</th>
					<th width="40px" class="page_config" title="In a new tab/window">New</th>
					<th width="50px" class="page_config" title="Add tool name to URL">Add Name</th>
					<th class="page_config">Groups</th>
					<th class="page_config">Description</th>
				</tr>
	<?php
		$sql_query = "SELECT  lm_tool_id,lm_tool_name,lm_tool_title,lm_tool_description,lm_tool_enabled, lm_tool_ssl, lm_tool_add_name2url, lm_tool_group_ids,lm_tool_new_page,lm_tool_order" .
			" FROM  lm_tools ORDER BY  lm_tool_order,lm_tool_id";
		if(($result = Clm::$cDB->db_query($sql_query)) &&
			(Clm::$cDB->db_num_rows($result) > 0)) {
			$row = 0;
			while($tool = Clm::$cDB->db_fetch_array($result)) {
				echo '<tr class="' . (($row & 1) ? 'page_config_odd':'page_config_even') . '">';
				echo '<td class="page_config" style="text-align: left">';
				echo '<a href="index.php?action=edit_tools&tool_edit_id=' . $tool['lm_tool_id'] . '" title="' . strip_tags($tool['lm_tool_title']) . '">' . $tool['lm_tool_name'] . '</a>';
				echo '</td>';
				echo '<td class="page_config" style="text-align: left">' . $tool['lm_tool_order'] . '</td>';
				echo '<td class="page_config">' . ($tool['lm_tool_enabled'] ? 'yes':'no') . '</td>';
				echo '<td class="page_config">' . ($tool['lm_tool_ssl'] ? 'yes':'no') . '</td>';
				echo '<td class="page_config" style="text-align: left">' . ($tool['lm_tool_new_page'] ? 'yes':'no') . '</td>';
				echo '<td class="page_config" style="text-align: left">' . ($tool['lm_tool_add_name2url'] ? 'yes':'no') . '</td>';
				echo '<td class="page_config">' . Clm::get_group_ids_text($tool['lm_tool_group_ids'],false) . '</td>';
				echo '<td class="page_config" style="text-align: left">' . $tool['lm_tool_description'] . '</td>';
				echo '</tr>' . "\n";
				$row++;
				} // while
			Clm::$cDB->db_free_result($result);
			} // if
		else echo '<tr class="page_config"><td class="page_config" style="text-align: left"><span class="msg_info">(No tools setup)</span></td></tr>' . "\n";
		?>
			</table>
		</td>
	</tr>
	<?php if(Clm::getMsgsCount()) { ?>
	<tr class="page_config_msgs">
		<td class="page_config_msgs">
			<?php echo Clm::getMsgs(); ?>
		</td>
	</tr>
	<?php } //if ?>
</table>
</td></tr></table>

<?php Clm::page_end_comment(__FILE__); ?>
