// Revision: $Id: client_visit_cntr.js 63 2013-11-13 12:22:17Z robert0609 $
// (C) BRAEWORKS 2005, site visit counter script
// client_visit_cntr.js
//
// requires bw_funcs.js

function showClientVisitsCntrCookie(sCookieID,sLeader,sTrailer,showFlg) {
	var expires = new Date();
	expires.setTime(expires.getTime() + 31536000000); //(1000 * 3600 * 24 * 365)); //plus 1 year

	// check for defaults
	if (( sCookieID == null) || ( ! sCookieID.length )) sCookieID = "visits";
	if (( sLeader == null) || ( ! sLeader.length )) sLeader = "Visited";
	if (( sTrailer == null) || ( ! sTrailer.length )) sTrailer = "times.";

	var visitsCntr = getCookie(sCookieID);
	if ( visitsCntr == null) {
		// document.write("New cookie");	// test
		visitsCntr = 1;
		setCookie(sCookieID,visitsCntr,expires);
		//say nothing may be disabled	document.write("This the first time you have visited this site.");
		} // if
	else {
		// document.write("Old cookie");	// test
		visitsCntr++;
		setCookie(sCookieID,visitsCntr,expires);
		if(showFlg) {
			// document.write(visitsCntr + sCookieID);	// test
			document.write(sLeader + " " + formatIntNumber(visitsCntr) + " " + sTrailer);
			} // if
		else document.write('&nbsp;');
		} // else
	} // showClientVisitsCntrCookie()


// EOF

