<?php
	// $Id: app_page_header.php 401 2016-08-02 13:56:02Z robert0609 $
	// Copyright BRAEWORKS (R) 2013

function get_header_admin_tools_db_text() {
	global $action;
	$text = '';
	if(Clm::$admin_tools_in_header) {
		if(Clm::get_tool_cnt() > 0) {
			ob_start();
			include "includes/tools.php";
			$tools = ob_get_contents();
			ob_end_clean();
			if(!empty($tools)) {
				$text .= Cbox_tool_tips::block('Tools', $tools);
				} // if
			} // if

		if(Clm::is_group_manager()) {
			ob_start();
			include "includes/config.php";
			$admin = ob_get_contents();
			ob_end_clean();
			if(!empty($admin)) {
				$text .= Cbox_tool_tips::block('Admin', $admin);
				} // if
			} // if
		} //if
	return $text;
} // get_header_admin_tools_db_text()

?>

<?php Clm::page_start_comment(__FILE__); ?>
	<div id="header">
	<table class="page_top">
		<?php if(Clm::is_browser_html5()) echo '<caption>Page header</caption>'; ?>
		<tr class="page_top">
			<td>&nbsp;</td>
			<td class="page_top" style="width: 35%; text-align: left;">
				<a href="<?php echo (Clm::$ssl_required ? LM_SSL_URL:LM_WWW_URL); ?>index.php?action=home" title="Home Page">
<?php		if(strlen(LMC_LOGO_IMAGE) > 4) {
				echo '<img class="logo" src="images/upload/' . LMC_LOGO_IMAGE . '" alt="Home">';
				} else echo 'Home';
?>
				</a>
<?php	$atxt = get_header_admin_tools_db_text();
		if(!empty($atxt)) echo $atxt . "\n";
?>
			</td>
				<td class="page_top" style="text-align: center;">
					<?php echo Clm::get_header_bar_title($action); ?>
				</td>
				<td class="page_top" style="width: 35%; text-align: right;">
					<?php
					if(Clm::is_user_logged_in()) {
						echo 'Logout: <a href="logout.php"' . (Clm::is_admin_user() ? ' title="Administrator"':(Clm::is_group_manager(-1) ? ' title="Manager"':'')) . '>' . $_SESSION['user']['name'] . '</a>';
						} // if
					else if((!INI_ALWAYS_LOGIN_BOOL) &&
						(LMC_SHOW_LOGIN_LINK) &&
						(Clm::$page_info['login_allowed']) &&
						($action != 'login')) {
						echo 'User: <a href="' . LM_SSL_URL . 'login.php">Login</a>';
						} // if
					else echo '&nbsp;';
					?>
				</td>
				<td>&nbsp;</td>
			</tr>
		</table>
	</div>
<?php Clm::page_end_comment(__FILE__); ?>
