<?php
	// $Id: app_top.php 316 2015-05-21 06:28:45Z robert0609 $
	// Copyright BRAEWORKS (R) 2013

	// Set the level of error reporting
	error_reporting(E_ALL | E_STRICT);

require_once 'includes/configure.php';
require_once LM_FS_INCLUDES_DIR . 'auto_class_loader.php';

if(!empty(Clm::$page_info['redirect_url'])) {
	header('Location: ' . Clm::$page_info['redirect_url'],true,301);
	exit(0);
	} // if

if(Clm::$page_info['closed']) {
	include("pages/closed.php");
	require_once 'includes/app_bottom.php';
	exit(0);
} // if

if((isset($_POST['download_log_file'])) && (!empty($_POST['download_log_file']))) {
	$log_path = LM_LOGS_DIR;
	$log_file = $_POST['download_log_file'];
	if(file_exists($log_path . $log_file)) {
		header('Content-Description: File Transfer');
		header('Content-Type: application/octet-stream');
		header('Content-Disposition: attachment; filename="' . $log_file . '"');
		header('Expires: 0');
		header('Cache-Control: must-revalidate');
		header('Pragma: public');
		header('Content-Length: ' . filesize($log_path . $log_file));
		readfile($log_path . $log_file);
		Clm::addMsg('Downloaded &quot;' . $log_file . '&quot;.','info');
		Clm::saveMsgs();
		exit(0);
		} // if
	} // if

