<?php
	// $Id: config.php 410 2016-10-11 13:04:28Z robert0609 $
	// Copyright BRAEWORKS (R) 2010


if(Clm::is_config_user()) {
	$row = 0;
?>

<?php Clm::page_start_comment(__FILE__); ?>
<table class="admin_db_container">
	<tr class="admin_db_container">
		<th class="admin_db_container"  title="Config and edit <?php echo strip_tags(LM_PROJECT_SHORTNAME . ' ' . LM_PROJECT_VERSION); ?> settings."><?php echo (Clm::is_admin_user() ? 'Admin':'Manage'); ?>:</th>
	</tr>
<?php if(Clm::is_admin_user()) { ?>
	<tr class="<?php echo (($row++ & 1) ? 'admin_db_container_odd':'admin_db_container_even'); ?>">
		<td class="admin_db_container">
			<a href="index.php?action=edit_search" title="Search install, theme, config, links, names, titles and descriptions.">Search</a>
		</td>
	</tr>
	<tr class="<?php echo (($row++ & 1) ? 'admin_db_container_odd':'admin_db_container_even'); ?>">
		<td class="admin_db_container">
			<a href="index.php?action=edit_users" title="Edit and change users">Users</a>
		</td>
	</tr>
	<tr class="<?php echo (($row++ & 1) ? 'admin_db_container_odd':'admin_db_container_even'); ?>">
		<td class="admin_db_container">
			<a href="index.php?action=edit_groups" title="Edit and change user groups">Groups</a>
		</td>
	</tr>
<?php	} // if ?>
	<tr class="<?php echo (($row++ & 1) ? 'admin_db_container_odd':'admin_db_container_even'); ?>">
		<td class="admin_db_container">
			<a href="index.php?action=edit_sections" title="Edit and change sections on main page">Sections</a>
		</td>
	</tr>
	<tr class="<?php echo (($row++ & 1) ? 'admin_db_container_odd':'admin_db_container_even'); ?>">
		<td class="admin_db_container">
<?php if(Clm::$cDB->get_row_count_in_table('lm_sections') > 0) { ?>
			<a href="index.php?action=edit_links" title="Edit and change links and URLs on main page">Links</a>
<?php	} else { ?>
			No sections setup.
<?php	} // if ?>
		</td>
	</tr>
<?php if(Clm::is_admin_user()) { ?>
	<tr class="<?php echo (($row++ & 1) ? 'admin_db_container_odd':'admin_db_container_even'); ?>">
		<td class="admin_db_container">
			<a href="index.php?action=edit_tools" title="Edit and change tools.">Tools</a>
		</td>
	</tr>
	<tr class="<?php echo (($row++ & 1) ? 'admin_db_container_odd':'admin_db_container_even'); ?>">
		<td class="admin_db_container">
			<a href="index.php?action=edit_config" title="Edit configuration settings">Config</a>
		</td>
	</tr>
	<tr class="<?php echo (($row++ & 1) ? 'admin_db_container_odd':'admin_db_container_even'); ?>">
		<td class="admin_db_container">
			<a href="index.php?action=edit_theme" title="Edit theme settings">Theme</a>
		</td>
	</tr>
	<tr class="<?php echo (($row++ & 1) ? 'admin_db_container_odd':'admin_db_container_even'); ?>">
		<td class="admin_db_container">
			<a href="index.php?action=edit_install" title="Edit installation settings">Install</a>
		</td>
	</tr>
<?php	if(strlen(INI_XML_SITEMAP_FILE) >= 2) { ?>
	<tr class="<?php echo (($row++ & 1) ? 'admin_db_container_odd':'admin_db_container_even'); ?>">
		<td class="admin_db_container">
			<a href="index.php?action=update_sitemap" title="Update XML sitemap">Sitemap</a>
		</td>
	</tr>
<?php		if((file_exists(INI_XML_SITEMAP_FILE . '.xml')) && (is_readable(INI_XML_SITEMAP_FILE . '.xml'))) { ?>
	<tr class="<?php echo (($row++ & 1) ? 'admin_db_container_odd':'admin_db_container_even'); ?>">
		<td class="admin_db_container">
			<a href="<?php echo INI_XML_SITEMAP_FILE . '.xml'; ?>" target="_blank" title="Show the Google XML sitemap on new tab/window">Show Map</a>
		</td>
	</tr>
<?php			} // if ?>
<?php		} // if ?>
	<tr class="<?php echo (($row++ & 1) ? 'admin_db_container_odd':'admin_db_container_even'); ?>">
		<td class="admin_db_container">
			<a href="index.php?action=log_view" title="View and manager log files.">View Logs</a>
		</td>
	</tr>
	<tr class="<?php echo (($row++ & 1) ? 'admin_db_container_odd':'admin_db_container_even'); ?>">
		<td class="admin_db_container">
			<a href="index.php?action=rebuild_setup" onclick="return confirm('Rebuild may take several minutes.');" title="Rebuild installation, theme and configuration settings.\nNOTE: May take several minutes.">Rebuild Setup</a>
		</td>
	</tr>
<?php	} // if ?>
	<tr class="<?php echo (($row++ & 1) ? 'admin_db_container_odd':'admin_db_container_even'); ?>">
		<td class="admin_db_container">
			<a href="index.php?action=about_lm" title="About <?php echo strip_tags(LM_PROJECT_SHORTNAME . ' ' . LM_PROJECT_VERSION) . (INI_DEBUG_BOOL ? ' (Debug)':'') . ', Sqlite V' . Clm::$cDB->m_sVersion; ?>">
				About <?php echo LM_PROJECT_SHORTNAME; ?>
			</a>
		</td>
	</tr>
	<tr class="<?php echo (($row++ & 1) ? 'admin_db_container_odd':'admin_db_container_even'); ?>">
		<td class="admin_db_container">
			<a href="index.php?action=lm_manual" title="<?php echo strip_tags(LM_PROJECT_SHORTNAME . ' ' . LM_PROJECT_VERSION); ?> user manual.">
				<?php echo LM_PROJECT_SHORTNAME; ?> Manual
			</a>
		</td>
	</tr>
</table>
<?php Clm::page_end_comment(__FILE__);
	} // if

