<?php
	// Revision: $Id: visitor_cntr.php 252 2015-04-20 06:19:48Z robert0609 $

	$cntrDat = 0;
	if (is_readable(LM_ACCESS_CNTR)) {
		$cntrDat = file_get_contents(LM_ACCESS_CNTR);
		} // if
	else Clm::$cDB->logEvent('INFO: Created new "' . basename(LM_ACCESS_CNTR) . '"');

	$cntrDat += 1;
	$_SESSION['visitorNum'] = $cntrDat;

	// Let's make sure the file exists and is writable first.
	if ((!file_exists(LM_ACCESS_CNTR)) || (is_writable(LM_ACCESS_CNTR))) {

		// In our example we're opening LM_ACCESS_CNTR in append mode.
		// The file pointer is at the bottom of the file hence
		// that's where $cntrDat will go when we fwrite() it.
		if (!$handle = fopen(LM_ACCESS_CNTR, 'w')) {
			Clm::$cDB->logEvent("ERROR: Cannot open file (" . LM_ACCESS_CNTR . ")");
			} // if
		else {
			// Write $cntrDat to our opened file.
			if (fwrite($handle, $cntrDat) === FALSE) {
				Clm::$cDB->logEvent("ERROR: Cannot write to file (" . LM_ACCESS_CNTR . ")");
				} // if
			// else  echo "Success, wrote ($cntrDat) to file (LM_ACCESS_CNTR)\n";
			fclose($handle);
			if(LMC_SHOW_VISITOR_COUNTER) echo "Visitor # " . number_format($cntrDat) . ".";
			} // else
		} // if
	else {
		Clm::$cDB->logEvent("ERROR: File not writebale (" . LM_ACCESS_CNTR . ")");
		} // else
