<?php
	// $Id: login.php 401 2016-08-02 13:56:02Z robert0609 $
	// Copyright BRAEWORKS (R) 2013

require_once 'includes/app_top.php';

unset($_SESSION['user']);
session_destroy();

if((INI_BLIND_LOGIN_BOOL) ||
	(INI_ALWAYS_LOGIN_BOOL)) {
	if(!Clm::$page_info['login_allowed']) {
		Clm::$cDB->logEvent('WARNING: Conflict with login and login not allowed.');
		exit(1);
		} // if
	} // if

if((!Clm::$page_info['login_allowed']) ||
	(Clm::is_user_logged_in())) {
	$url = LM_SSL_URL . 'index.php';
	header('Location: ' . $url);
	exit (0);
	} // if

if(INI_BLIND_LOGIN_BOOL) {
	if ((!isset($_SERVER['PHP_AUTH_USER'])) ||
		(empty($_SERVER['PHP_AUTH_USER'])) ||
		(!isset($_SERVER['PHP_AUTH_PW'])) ||
		(isset($_SESSION['BLIND_LOGIN_FAILED']))) {
		session_destroy();
		session_regenerate_id();	// stop the re-occurring redirect
		if(isset($_SESSION['BLIND_LOGIN_FAILED'])) unset($_SESSION['BLIND_LOGIN_FAILED']);	// in case
		header('WWW-Authenticate: Basic realm="to access ' . LMC_TITLE . '"');	// putup login dialog box
		header('HTTP/1.0 401 Unauthorized');
		echo 'Cancelled';	// pressed the cancel button
		exit(0);
		} // if
	// echo '<p>Hello "' . $_SERVER['PHP_AUTH_USER'] . '"</p>';	// test
	// echo '<p>You entered "' . $_SERVER['PHP_AUTH_PW'] . '" as your password.</p>';	// test

	// setup variables for the login process
	$action = 'login';
	$_GET['user'] = $_SERVER['PHP_AUTH_USER'];
	$_SERVER['PHP_AUTH_USER'] = '';
	$_GET['password'] = $_SERVER['PHP_AUTH_PW'];
	$_SERVER['PHP_AUTH_PW'] = '';
	} // if

$url = LM_SSL_URL . 'index.php?action=login';
if((isset($_GET['user'])) && (!empty($_GET['user']))) {
	$url .= '&user=' . urlencode($_GET['user']);
	if((isset($_GET['password'])) && (!empty($_GET['password']))) {
		$url .= '&password=' . urlencode($_GET['password']);
		} // if
	} // if
header('Location: ' . $url);
require_once 'includes/app_bottom.php';

