<?php
	// $Id: edit_groups.php 415 2016-10-16 05:48:04Z robert0609 $
	// Copyright BRAEWORKS (R) 2013

$lm_group_id = 0;
$lm_group_op = '';
if($action == 'edit_groups') { // a bit of caution
	if(((isset($_POST['edit'])) && (isset($_POST['group_edit_id'])) && ((int)$_POST['group_edit_id'] > 0)) ||
		((isset($_GET['group_edit_id'])) && ((int)$_GET['group_edit_id'] > 0))) {
		$lm_group_op = 'edit';

		if(isset($_POST['group_edit_id'])) $lm_group_id = (int)$_POST['group_edit_id'];
		else if(isset($_GET['group_edit_id'])) $lm_group_id = (int)$_GET['group_edit_id'];
		else { // what??
			$lm_group_op = '';
			$lm_group_id = 0;
			} // else

		$sql_query = "SELECT  lm_group_name,lm_group_enabled, lm_group_admin, lm_group_order" .
			", lm_group_manager_ids, lm_group_description,lm_group_order" .
			", DATETIME(lm_group_added, 'LocalTime') as  lm_group_added" .
			", DATETIME(lm_group_updated, 'LocalTime') as  lm_group_updated" .
			" FROM  lm_groups WHERE  lm_group_id = '" . (int)$lm_group_id . "'";
		if(($result = Clm::$cDB->db_query($sql_query)) &&
			(Clm::$cDB->db_num_rows($result) > 0) &&
			($group = Clm::$cDB->db_fetch_array($result))) {
			$lm_group_name = $group['lm_group_name'];
			$lm_group_admin = $group['lm_group_admin'];
			$lm_group_description = $group['lm_group_description'];
			$lm_group_order = $group['lm_group_order'];
			$lm_group_enabled = $group['lm_group_enabled'];
			$lm_group_added = $group['lm_group_added'];
			$lm_group_updated = $group['lm_group_updated'];
			$lm_group_manager_ids = $group['lm_group_manager_ids'];
			Clm::$cDB->db_free_result($result);
			} // if
		else { // not found
			$lm_group_id = 0;
			$lm_group_op = '';
			$lm_group_added = '';
			$lm_group_updated = '';
			} // else
		} // if
	else if((isset($_POST['delete'])) &&
		((isset($_POST['group_edit_id'])) || (isset($_POST['lm_group_id'])))) {
		$lm_group_op = 'delete';
		$lm_group_id = (int)(isset($_POST['lm_group_id']) ? $_POST['lm_group_id']:$_POST['group_edit_id']);

		$sql_query = "SELECT  lm_group_name,lm_group_enabled" .
					" FROM  lm_groups WHERE  lm_group_id = '" . (int)$lm_group_id . "'";
		if(($result = Clm::$cDB->db_query($sql_query)) &&
			(Clm::$cDB->db_num_rows($result) > 0) &&
			($group = Clm::$cDB->db_fetch_array($result))) {
			$lm_group_name = $group['lm_group_name'];
			$lm_group_enabled = $group['lm_group_enabled'];
			} // if
		} // else if
	else if((isset($_POST['confirm_delete'])) && (isset($_POST['lm_group_id']))) {
		$lm_group_op = 'confirm_delete';
		$lm_group_id = (int)$_POST['lm_group_id'];

		$sql_query = "DELETE FROM  lm_groups WHERE  lm_group_id = '" . (int)$lm_group_id . "'";
		Clm::$cDB->db_query($sql_query);
		$lm_group_id = 0;
		} // else if
	else if(isset($_POST['add'])) {
		$cols = Clm::$cDB->get_columns_list('lm_groups',true);
		foreach($cols as $c => $v) $$c = $v;
		$lm_group_op = 'add';
		$lm_group_id = 0;
		} // else if
	else if((isset($_POST['insert'])) && (isset($_POST['lm_group_id']))) {
		$lm_group_op = 'insert';
		} // else if
	else if((isset($_POST['save'])) && (isset($_POST['lm_group_id']))) {
		$lm_group_op = 'save';
		} // else if
	else if((INI_ALLOW_TABLE_RELOAD_BOOL) && (isset($_POST['reloadDB']))) {
		$lm_group_op = 'reloadDB';
		$lm_group_id = 0;
		} // else if
	else if(isset($_POST['cancel'])) {
		$lm_group_op = 'cancel';
		$lm_group_id = 0;
		} // else if

	if(($lm_group_op == 'insert') || ($lm_group_op == 'save')) {

		$lm_group_id = (int)$_POST['lm_group_id'];
		$lm_group_name = html_entity_decode($_POST['lm_group_name']);
		$lm_group_admin = (isset($_POST['lm_group_admin']) ? 1:0);
		$lm_group_manager_ids = (isset($_POST['lm_group_manager_ids']) ? implode(':',$_POST['lm_group_manager_ids']):0);
		$lm_group_description = html_entity_decode($_POST['lm_group_description']);
		$lm_group_enabled = (isset($_POST['lm_group_enabled']) ? 1:0);
		$lm_group_order = (int)$_POST['lm_group_order'];

		if($lm_group_op == 'save') {
			if((empty($lm_group_name)) || (strlen($lm_group_name) < LMC_MIN_NAME_LEN)) {
				Clm::addMsg('Name too short.');
				} // if
			else if(Clm::is_group_name_inuse($lm_group_name,
				(((int)$lm_group_id > 0) ? Clm::$cDB->get_data_in_table('lm_groups','lm_group_name','lm_group_id = ' . (int)$lm_group_id):''))) {
				Clm::addMsg('Name already in use');
				} // else if
			} // if
		else if($lm_group_op == 'insert') {
			if((empty($lm_group_name)) || (strlen($lm_group_name) < LMC_MIN_NAME_LEN)) {
				Clm::addMsg('Name too short.');
				} // if
			if(Clm::is_group_name_inuse($lm_group_name)) {
				Clm::addMsg('Name already in use.');
				} // else if
			} // else

		if(!Clm::getMsgsCount('error')) {	// update it
			$fields = array();
			$fields['lm_group_name'] = $lm_group_name;
			$fields['lm_group_description'] = $lm_group_description;
			$fields['lm_group_enabled'] = $lm_group_enabled;
			$fields['lm_group_admin'] = $lm_group_admin;
			$fields['lm_group_manager_ids'] = $lm_group_manager_ids;
			$fields['lm_group_order'] = $lm_group_order;

			if($lm_group_op == 'insert') {
				if(!Clm::$cDB->db_perform('lm_groups',$fields,'insert','')) {
					Clm::addMsg('Group insert, ' . $lm_group_name . " failed");
					Clm::$cDB->logEvent('ERROR: group insert, ' . $lm_group_name);
					} // if
				else {
					unset($_SESSION['lm_group_id']);
					Clm::addMsg('New group data saved.','success');
					} // else
				} // if
			else if($lm_group_op = 'save') {
				if(!Clm::$cDB->db_perform('lm_groups',$fields,'update',"lm_group_id = " . (int)$lm_group_id . "")) {
					Clm::addMsg('Group update, ' . $lm_group_name . " failed");
					Clm::$cDB->logEvent('ERROR: group update, ' . $lm_group_name);
					} // if
				else {
					unset($_SESSION['lm_group_id']);
					Clm::addMsg('Saved group data.','success');
					} // else
				} else
			$lm_group_id = 0;
			$lm_group_op = '';
			} // if
		} // if
	} // if
$cnt = Clm::$cDB->get_row_count_in_table('lm_groups');
?>

<?php Clm::page_start_comment(__FILE__); ?>

<table class="page_container"><tr class="page_container"><td class="page_container">
<table class="page_config">
	<tr class="page_config">
		<th class="page_config">
			<a name="top"></a>
<!--			<span class="admin-right-floating-box"><a onclick="javascript:scroll2Name('top');" title="Back to Top">Top</a></span>-->
			<h1>Groups</h1>
		</th>
	</tr>
	<?php if($lm_group_op == 'reloadDB') { ?>
	<tr class="page_config">
		<td class="page_config" valign="bottom">
			Reloading Groups Config
			<?php Clm::$cDB->installDatabase('lm_groups',true ,true); ?>
		</td>
	</tr>
	<?php } // if ?>
	<?php if(Clm::getMsgsCount()) { ?>
	<tr class="page_config_msgs">
		<td class="page_config_msgs">
			<?php echo Clm::getMsgs(); ?>
		</td>
	</tr>
	<?php } //if ?>
	<form method="post" name="edit_group" action="<?php echo $_SERVER['PHP_SELF'] . '?action=edit_groups'; ?>" method="post" enctype="multipart/form-data">
	<?php if(isset($_GET['keywords'])) echo '<input type="hidden" name="search" value="' . $_GET['keywords'] . '"/>'; ?>
	<tr class="page_config">
		<td class="page_config" valign="bottom">
			Select group name:&nbsp;
			<?php echo  Clm::gen_group_selection_list('group_edit_id',$lm_group_id,1); ?>
			<?php if($cnt > 0) { ?>
			&nbsp;&nbsp;
			<button name="edit" value="edit" type="submit">Edit</button>
			&nbsp;&nbsp;
			<button name="delete" value="delete" type="submit">Delete</button>
			<?php	} //if ?>
			&nbsp;&nbsp;
			<button name="add" value="add" type="submit">Add</button>
			<?php if(INI_ALLOW_TABLE_RELOAD_BOOL) { ?>
			&nbsp;&nbsp;
			<button name="reloadDB" value="reloadDB" type="submit" title="Clear and re-initialise groups table in database." onClick="return confirm('Clear and re-initialise groups table in database?')">Reload</button>
			<?php	} // if ?>
			<?php Clm_search::get_form_return_link(); ?>
		</td>
	</tr>

	<?php
	if((($lm_group_op == 'edit') || ($lm_group_op == 'save') ||
		($lm_group_op == 'add') || ($lm_group_op == 'insert')) &&
		(isset($lm_group_id))) {
	?>
	<tr class="page_config">
		<th class="page_config">
			<?php if($lm_group_id == 0) {
				echo 'Add Group';
				} // if
			else {
				echo 'Edit Group' .
					'&nbsp;&nbsp;<span class="page_config">(Added:&nbsp;' . $lm_group_added .
					'&nbsp;&nbsp;Updated:&nbsp;' . $lm_group_updated . ')</span>';
				if((isset($_GET['name'])) && ($_GET['name'] == $lm_group_name))
					echo '&nbsp;&nbsp;<span class="msg_success"><img src="images/success.gif">Found here</span>' .
						'&nbsp;&nbsp;<a href="index.php?action=edit_search&search=' . $_GET['keywords'] . '" title="Search for:' . urldecode ($_GET['keywords']) . '">Return to search.</a>';
				} // else
			?>
		</th>
	</tr>
	<input type="hidden" name="lm_group_id" value="<?php echo $lm_group_id; ?>"/>
	<input type="hidden" name="lm_group_name_old" value="<?php echo htmlentities($lm_group_name); ?>"/>
	</tr>
	<tr class="page_config">
		<td class="page_config">
			<table class="page_config">
				<tr>
					<td width ="100px" class="page_config">Name:</td>
					<td class="page_config">
						<input type="text" name="lm_group_name" size="40" value="<?php echo $lm_group_name; ?>" title="Minimum of 4 characters" autocapitalize="off"/>
					</td>
				</tr>
				<tr>
					<td width ="100px" class="page_config">Description:</td>
					<td class="page_config">
						<input type="text" name="lm_group_description" size="80" value="<?php echo $lm_group_description; ?>" title="Group description (for admin notes, not displayed to user)." autocapitalize="off"/>
					</td>
				</tr>
				<tr>
					<td width ="100px" class="page_config">Order:</td>
					<td class="page_config">
						<input type="text" name="lm_group_order" size="4" value="<?php echo $lm_group_order; ?>" title="Group sort order." autocapitalize="off"/>
					</td>
				</tr>
				<tr>
					<td width ="100px" class="page_config">Admin:</td>
					<td class="page_config">
						<input type="checkbox" name="lm_group_admin"<?php echo ($lm_group_admin == true ? ' CHECKED':'');?>/>
					</td>
				</tr>
				<tr>
					<td width ="100px" class="page_config" valign="top">Select manager/s:</td>
					<td class="page_config">
						<?php echo  Clm::gen_group_manager_selection_list('lm_group_manager_ids[]',$lm_group_manager_ids,10, ' multiple'); ?>
					</td>
				</tr>
				<tr>
					<td width ="100px" class="page_config">Enabled:</td>
					<td class="page_config">
						<input type="checkbox" name="lm_group_enabled"<?php echo ($lm_group_enabled == true ? ' CHECKED':'');?>/>
					</td>
				</tr>
			</table>
		</td>
	</tr>

	<tr class="page_config">
		<td class="page_config" style="text-align: right">
			<?php if($lm_group_id == 0) { ?>
			<button name="insert" value="insert" type="submit">Insert</button>
			<?php } else { ?>
			<button name="save" value="save" type="submit">Save</button>
			<?php	} // else ?>
			&nbsp;&nbsp;
			<button name="cancel" value="cancel" type="submit">Cancel</button>
		</td>
	</tr>

	<?php } else if(($lm_group_op == 'delete') && (isset($lm_group_id)) && ($lm_group_id > 0)) { ?>
	<tr class="page_config"><th class="page_config">Delete Group - <?php echo $lm_group_name; ?></th></tr>
	<input type="hidden" name="lm_group_id" value="<?php echo $lm_group_id; ?>"/>
	<input type="hidden" name="lm_group_name" value="<?php echo htmlentities($lm_group_name); ?>"/>
	<tr class="page_config">
		<td class="page_config">
			Please confirm.
			&nbsp;&nbsp;
			<button name="confirm_delete" value="confirm_delete" type="submit">Confirm Delete</button>
			&nbsp;&nbsp;
			<button name="cancel" value="cancel" type="submit">Cancel</button>
		</td>
	</tr>
	<?php	}  ?>
	</form>
	<tr class="page_config"><th class="page_config">Summary</th></tr>
	<tr class="page_config">
		<td class="page_config" style="text-align: left">
			<table class="page_config">
				<tr>
					<th width ="150px" class="page_config">Group</th>
					<th width ="70px" class="page_config">Order</th>
					<th width ="70px" class="page_config">Enabled</th>
					<th width ="70px" class="page_config" title="Global web site administrator group.">Admin</th>
					<th width ="150px" class="page_config" title="Group Managers">Manager/s</th>
					<th class="page_config">Description</th>
				</tr>
	<?php
		$sql_query = "SELECT  lm_group_id,lm_group_name,lm_group_description,lm_group_enabled,lm_group_order,lm_group_admin,lm_group_manager_ids" .
			" FROM  lm_groups ORDER BY  lm_group_order,lm_group_id";
		if(($result = Clm::$cDB->db_query($sql_query)) &&
			(Clm::$cDB->db_num_rows($result) > 0)) {
			$row = 0;
			while($group = Clm::$cDB->db_fetch_array($result)) {
				echo '<tr class="' . (($row & 1) ? 'page_config_odd':'page_config_even') . '">';
				echo '<td class="page_config">';
				echo '<a href="index.php?action=edit_groups&group_edit_id=' . $group['lm_group_id'] . '">' . $group['lm_group_name'] . '</a></td>';
				echo '<td class="page_config">' . $group['lm_group_order'] . '</td>';
				echo '<td class="page_config">' . ($group['lm_group_enabled'] ? 'yes':'no') . '</td>';
				echo '<td class="page_config">' . ($group['lm_group_admin'] ? 'yes':'no') . '</td>';
				echo '<td class="page_config">' . Clm::get_group_manager_ids_text($group['lm_group_manager_ids'],false) . '</td>';
				echo '<td class="page_config">' . $group['lm_group_description'] . '</td>';
				echo '</tr>' . "\n";
				$row++;
				} // while
			} // if
		else echo '<tr class="page_config"><td class="page_config" style="text-align: left"><span class="msg_warning">(No groups setup)</span></td></tr>' . "\n";
		?>
			</table>
		</td>
	</tr>
	<?php if(Clm::getMsgsCount()) { ?>
	<tr class="page_config_msgs">
		<td class="page_config_msgs">
			<?php echo Clm::getMsgs(); ?>
		</td>
	</tr>
	<?php } //if ?>
</table>
</td></tr></table>

<?php Clm::page_end_comment(__FILE__); ?>
