<?php
	// $Id: edit_links.php 415 2016-10-16 05:48:04Z robert0609 $
	// Copyright BRAEWORKS (R) 2013

$cLMC = new Clmc();

$lm_link_id = 0;
$lm_link_op = '';
$lm_group_id = 0;
$lm_section_id = 0;
if($action == 'edit_links') { // a bit of caution
	if(((isset($_POST['edit'])) && (isset($_POST['link_edit_id'])) && ((int)$_POST['link_edit_id'] > 0)) ||
		((isset($_GET['link_edit_id'])) && ((int)$_GET['link_edit_id'] > 0))) {
		$lm_link_op = 'edit';

		if(isset($_POST['link_edit_id'])) $lm_link_id = (int)$_POST['link_edit_id'];
		else if(isset($_GET['link_edit_id'])) $lm_link_id = (int)$_GET['link_edit_id'];
		else { // what??
			$lm_link_op = '';
			$lm_link_id = 0;
			} // else

		$sql_query = "SELECT  lm_link_name,lm_link_section_id, lm_link_url, lm_link_order" .
			", lm_link_name , lm_link_description, lm_link_title" .
			", lm_link_image_url, lm_link_new_page, lm_link_ssl, lm_link_enabled, lm_link_add_name2url" .
			", DATETIME(lm_link_added, 'LocalTime') as  lm_link_added" .
			", DATETIME(lm_link_updated, 'LocalTime') as  lm_link_updated" .
			" FROM  lm_links WHERE  lm_link_id = '" . (int)$lm_link_id . "'";
		if(($result = Clm::$cDB->db_query($sql_query)) &&
			(Clm::$cDB->db_num_rows($result) > 0) &&
			($link = Clm::$cDB->db_fetch_array($result))) {
			$lm_link_name = $link['lm_link_name'];
			$lm_link_section_id = $link['lm_link_section_id'];
			$lm_link_url = $link['lm_link_url'];
			$lm_link_description = $link['lm_link_description'];
			$lm_link_title = $link['lm_link_title'];
			$lm_link_image_url = $link['lm_link_image_url'];
			$lm_link_order = $link['lm_link_order'];
			$lm_link_ssl = $link['lm_link_ssl'];
			$lm_link_new_page = $link['lm_link_new_page'];
			$lm_link_add_name2url = $link['lm_link_add_name2url'];
			$lm_link_enabled = $link['lm_link_enabled'];
			$lm_link_added = $link['lm_link_added'];
			$lm_link_updated = $link['lm_link_updated'];
			Clm::$cDB->db_free_result($result);
			} // if
		else { // not found
			$lm_link_id = 0;
			$lm_link_op = '';
			$lm_link_added = '';
			$lm_link_updated = '';
			$lm_group_id = 0;
			$lm_section_id = 0;
			} // else
		} // if
	else if((isset($_POST['delete'])) &&
		((isset($_POST['link_edit_id'])) || (isset($_POST['lm_link_id'])))) {
		$lm_link_op = 'delete';
		$lm_link_id = (int)(isset($_POST['lm_link_id']) ? $_POST['lm_link_id']:$_POST['link_edit_id']);

		$sql_query = "SELECT  lm_link_name,lm_link_enabled" .
					" FROM  lm_links WHERE  lm_link_id = '" . (int)$lm_link_id . "'";
		if(($result = Clm::$cDB->db_query($sql_query)) &&
			(Clm::$cDB->db_num_rows($result) > 0) &&
			($link = Clm::$cDB->db_fetch_array($result))) {
			$lm_link_name = $link['lm_link_name'];
			$lm_link_enabled = $link['lm_link_enabled'];
			} // if
		} // else if
	else if((isset($_POST['confirm_delete'])) && (isset($_POST['lm_link_id']))) {
		$lm_link_op = 'confirm_delete';
		$lm_link_id = (int)$_POST['lm_link_id'];

		$sql_query = "DELETE FROM  lm_links WHERE  lm_link_id = '" . (int)$lm_link_id . "'";
		Clm::$cDB->db_query($sql_query);
		new Clm_xml_sitemap();	// do sitemap
		$lm_link_id = 0;
		} // else if
	else if(isset($_POST['add'])) {
		$cols = Clm::$cDB->get_columns_list('lm_links',true);
		foreach($cols as $c => $v) $$c = $v;
		$lm_link_op = 'add';
		$lm_link_id = 0;
		} // else if
	else if((isset($_POST['insert'])) && (isset($_POST['lm_link_id']))) {
		$lm_link_op = 'insert';
		} // else if
	else if((isset($_POST['save'])) && (isset($_POST['lm_link_id']))) {
		$lm_link_op = 'save';
		} // else if
	else if((INI_ALLOW_TABLE_RELOAD_BOOL) && (isset($_POST['reloadDB']))) {
		$lm_link_op = 'reloadDB';
		$lm_link_id = 0;
		} // else if
	else if(isset($_POST['cancel'])) {
		$lm_link_op = 'cancel';
		$lm_link_id = 0;
		} // else if
	else if(isset($_POST['import'])) {
		$lm_link_op = 'import';
		$lm_link_id = 0;
		if(Clm_export::import_links(LM_FS_IMPORT_DIR . 'lm_links.csv','lm_link_upload_csv')) {
			// nothing yet
			} // if
		} // else if

	if(($lm_link_op == 'save') || ($lm_link_op == 'insert')) {
		// do it once
		$lm_link_id = (int)$_POST['lm_link_id'];
		$lm_link_url = $cLMC->get_url('lm_link_url',Clm::$cDB->get_data_in_table('lm_links','lm_link_url','lm_link_id = ' . (int)$lm_link_id));
		$lm_link_name = html_entity_decode($_POST['lm_link_name']);
		$lm_link_description = html_entity_decode($_POST['lm_link_description']);
		$lm_link_title = html_entity_decode($_POST['lm_link_title']);
		$lm_link_order = (int)$_POST['lm_link_order'];
		$lm_link_section_id = (int)$_POST['lm_link_section_id'];
		$lm_link_ssl = (isset($_POST['lm_link_ssl']) ? 1:0);
		$lm_link_enabled = (isset($_POST['lm_link_enabled']) ? 1:0);
		$lm_link_new_page = (isset($_POST['lm_link_new_page']) ? 1:0);
		$lm_link_add_name2url = (isset($_POST['lm_link_add_name2url']) ? 1:0);
		$lm_link_added = html_entity_decode($_POST['lm_link_added']);
		$lm_link_updated = html_entity_decode($_POST['lm_link_updated']);
		$lm_link_image_url = $cLMC->get_image('lm_link_image_url',Clm::$cDB->get_data_in_table('lm_links','lm_link_image_url','lm_link_id = ' . (int)$lm_link_id));

		if((empty($lm_link_name)) || (strlen($lm_link_name) < LMC_MIN_NAME_LEN)) {
			Clm::addMsg('Name too short.');
			} // if
		else if($lm_link_section_id == 0) {
			Clm::addMsg('Select a section.');
			} // if
		else if(Clm::is_link_name_inuse($lm_link_name,
			(((int)$lm_link_id > 0) ? Clm::$cDB->get_data_in_table('lm_links','lm_link_name','lm_link_id = ' . (int)$lm_link_id):''))) {
			Clm::addMsg('Name already in use.');
			} // else if

		if((empty($lm_link_url)) || (strlen($lm_link_url) < 4)) {
			Clm::addMsg('URL too short or incorrect.');
			} // if
		else if((!$lm_link_new_page) && (!Clm::is_iframeable_url($lm_link_url))) {
			if(LMC_EXT_URL_NEW_PAGE) {
				$lm_link_new_page = 1;
				Clm::addMsg ('URL has been changed to new tab/window.','info');
				} // if
			} // if

		if(!Clm::getMsgsCount('error')) {	// update it
			$fields = array();
			$fields['lm_link_name'] = $lm_link_name;
			$fields['lm_link_url'] = $lm_link_url;
			$fields['lm_link_description'] = $lm_link_description;
			$fields['lm_link_title'] = $lm_link_title;
			if(isset($lm_link_image_url)) $fields['lm_link_image_url'] = $lm_link_image_url;
			$fields['lm_link_order'] = $lm_link_order;
			$fields['lm_link_section_id'] = $lm_link_section_id;
			$fields['lm_link_ssl'] = $lm_link_ssl;
			$fields['lm_link_enabled'] = $lm_link_enabled;
			$fields['lm_link_new_page'] = $lm_link_new_page;
			$fields['lm_link_add_name2url'] = $lm_link_add_name2url;
			if(($lm_link_op == 'insert') &&
				(!Clm::$cDB->db_perform('lm_links',$fields,'insert',''))) {
				Clm::addMsg('Link insert, ' . $lm_link_name . " failed");
				Clm::$cDB->logEvent('ERROR: link insert, ' . $lm_link_name);
				} // if
			else if(($lm_link_op == 'save') &&
				(!Clm::$cDB->db_perform('lm_links',$fields,'update',"lm_link_id = " . (int)$lm_link_id . ""))) {
				Clm::addMsg('Link update, ' . $lm_link_name . " failed");
				Clm::$cDB->logEvent('ERROR: link update, ' . $lm_link_name);
				} // if
			else {
				unset($_SESSION['lm_link_id']);
				Clm::addMsg('Saved link config.','success');
				Clm_export::export_links(LM_FS_EXPORT_DIR . 'lm_links.csv');
				} // else
			new Clm_xml_sitemap();	// do sitemap
			$lm_link_id = 0;
			$lm_link_op = '';
			} // if

		} // if
	} // if
$cnt = Clm::$cDB->get_row_count_in_table('lm_links');
if(!($section_cnt = Clm::$cDB->get_row_count_in_table('lm_sections'))) {
	Clm::addMsg('No sections setup','error');
	} // if
?>

<?php Clm::page_start_comment(__FILE__); ?>

<table class="page_container"><tr class="page_container"><td class="page_container">
<table class="page_config">
	<tr class="page_config">
		<th class="page_config">

			<?php echo Clm::get_admin_scroll2top_anchor(false); ?>

			<h1>Links Config</h1>
		</th>
	</tr>
	<?php if($lm_link_op == 'reloadDB') { ?>
	<tr class="page_config">
		<td class="page_config" valign="bottom">
			<?php Clm::$cDB->installDatabase('lm_links',true ,true); ?>
		</td>
	</tr>
	<tr class="page_config"><td class="page_config">&nbsp;</td></tr>
	<?php } // if ?>
	<?php if(Clm::getMsgsCount()) { ?>
	<tr class="page_config_msgs">
		<td class="page_config_msgs">
			<?php echo Clm::getMsgs(); ?>
		</td>
	</tr>
	<?php } //if ?>
	<form method="post" name="edit_link" action="<?php echo $_SERVER['PHP_SELF'] . '?action=edit_links'; ?>" method="post" enctype="multipart/form-data">
	<?php if(isset($_GET['keywords'])) echo '<input type="hidden" name="search" value="' . $_GET['keywords'] . '"/>'; ?>
	<tr class="page_config">
		<td class="page_config" valign="bottom">
			Select link name:&nbsp;
			<?php echo  Clm::gen_link_selection_list('link_edit_id',$lm_link_id,'size="1"'); ?>
			<?php if($cnt > 0) { ?>
			&nbsp;&nbsp;
			<button name="edit" value="edit" type="submit">Edit</button>
			&nbsp;&nbsp;
			<button name="delete" value="delete" type="submit">Delete</button>
			<?php	} //if ?>
			&nbsp;&nbsp;
			<button name="add" value="add" type="submit">Add</button>
			<?php if(INI_ALLOW_TABLE_RELOAD_BOOL) { ?>
		</td>
	</tr>
	<tr class="page_config">
		<td class="page_config" valign="bottom">
			Link table operations:&nbsp;
			<button name="reloadDB" value="reloadDB" type="submit" title="Clear and re-initialise links table in database." onClick="return confirm('Clear and re-initialise links table in database?')">Reload</button>
			<?php	} // if ?>
			<?php if(LMC_ALLOW_CSV_EXPORT_IMPORT) {
				Clm_export::export_links(LM_FS_EXPORT_DIR . 'lm_links.csv');
				$url = LM_SSL_URL . str_replace(LM_FS_BASE_DIR, '', LM_FS_EXPORT_DIR . 'lm_links.csv'); ?>
			&nbsp;&nbsp;
			<button name="export" value="export" type="button" title="Download links to a csv file." onclick="window.open('<?php echo $url; ?>');">Export</button>
<!--@TODO			<a href="<?php echo $url; ?>" class="page_config" title="Download link csv file.">Export</a>-->
			&nbsp;&nbsp;
			<button name="import" id="import_button" value="import" type="submit" title="Upload links to lm_links.csv and import" onClick="return enable_import();">Import</button>
			<script type="text/javascript">
				function enable_import() {
					var b = document.getElementsByName("lm_link_upload_csv_new")[0].value;
					if(b.length < 6) {
						alert('Select links import file first.');
						return false;
						} // if
					 return confirm('Import links table from file?');
					} // enable_import()
			</script>
			<noscript></noscript>
			<?php echo $cLMC->input_txt_file('lm_link_upload_csv','lm_links.csv','sqlite/export_import'); ?>
			<?php	} // if ?>
			<?php Clm_search::get_form_return_link(); ?>
		</td>
	</tr>

	<?php
	if((($lm_link_op == 'edit') || ($lm_link_op == 'save') ||
		($lm_link_op == 'add') || ($lm_link_op == 'insert')) &&
		(isset($lm_link_id))) {
	?>
	<tr class="page_config"><td class="page_config">&nbsp;</td></tr>
	<tr class="page_config">
		<th class="page_config">
			<?php if($lm_link_id == 0) {
				echo 'Add Link';
				} // if
			else {
				echo 'Edit Link' .
					'&nbsp;&nbsp;<span class="page_config">(Added:&nbsp;' . $lm_link_added .
					'&nbsp;&nbsp;Updated:&nbsp;' . $lm_link_updated . ')</span>';
				if((isset($_GET['name'])) && ($_GET['name'] == $lm_link_name))
					echo '&nbsp;&nbsp;<span class="msg_success"><img src="images/success.gif">Found here</span>' .
						'&nbsp;&nbsp;<a href="index.php?action=edit_search&search=' . $_GET['keywords'] . '" title="Search for:' . urldecode ($_GET['keywords']) . '">Return to search.</a>';
				} // else
			?>
		</th>
	</tr>
	<input type="hidden" name="lm_link_id" value="<?php echo $lm_link_id; ?>"/>
	<input type="hidden" name="lm_link_name_old" value="<?php echo htmlentities($lm_link_name); ?>"/>
	<input type="hidden" name="lm_link_added" value="<?php echo htmlentities($lm_link_added); ?>"/>
	<input type="hidden" name="lm_link_updated" value="<?php echo htmlentities($lm_link_updated); ?>"/>
	<tr>
		<td>
			<table class="page_config">
				<tr>
					<td width ="100px" class="page_config">Section:</td>
					<td class="page_config">
						<?php echo  Clm::gen_section_selection_list('lm_link_section_id', $lm_link_section_id, 'size="1"'); ?>
					</td>
				</tr>
				<tr>
					<td width ="100px" class="page_config">Name:</td>
					<td class="page_config">
						<input type="text" name="lm_link_name" size="40" value="<?php echo $lm_link_name; ?>" title="Unique link name. Appears on page as a link heading. Minimum of 4 charaters" autocapitalize="off"/>
					</td>
				</tr>
				<tr>
					<td width ="100px" class="page_config">Link URL:</td>
					<td class="page_config">
						<input type="text" name="lm_link_url" size="60" value="<?php echo $lm_link_url; ?>" title="Link URL. The clickable link the new web page. Minimum of 4 charaters, if not on this server needs to be a full URI including the protocol (e.g. http:// , etc)." autocapitalize="off"/>
					</td>
				</tr>
				<tr>
					<td class="page_config">Description:</td>
					<td class="page_config">
						<input type="text" name="lm_link_description" size="80" value="<?php echo $lm_link_description; ?>" title="Link description (optional), appears next to the name." autocapitalize="off"/>
					</td>
				</tr>
				<tr>
					<td class="page_config">Title:</td>
					<td class="page_config">
						<input type="text" name="lm_link_title" size="80" value="<?php echo $lm_link_title; ?>" title="Link title (optional), appears when mouse is hovered over link name or image." autocapitalize="off"/>
					</td>
				</tr>
				<tr>
					<td class="page_config">Image URL:</td>
					<td class="page_config" title="Link image or icon (optional). Images are stored in the images/upload/ directory.">
						<?php echo $cLMC->input_image('lm_link_image_url', $lm_link_image_url); ?>
					</td>
				</tr>
				<tr>
					<td class="page_config">Display Order:</td>
					<td class="page_config">
						<input type="text" name="lm_link_order" size="5" value="<?php echo $lm_link_order; ?>" title="Sorting order of link. Used to control the order of the link in this section. Low numbers at the top of the page, ascending down the page." autocapitalize="off"/>
					</td>
				</tr>
				<tr>
					<td class="page_config">SSL:</td>
					<td class="page_config">
						<input type="checkbox" name="lm_link_ssl"<?php echo ($lm_link_ssl == 1 ? ' CHECKED':'');?> title="Check to open URL using SSL encrytion, uncheck to use the default"/>
					</td>
				</tr>
				<tr>
					<td class="page_config">New Tab:</td>
					<td class="page_config">
						<input type="checkbox" name="lm_link_new_page"<?php echo ($lm_link_new_page == 1 ? ' CHECKED':'');?> title="Check to open URL in a new browser tab or window, uncheck to disable new tab or window"/>
					</td>
				</tr>
				<tr>
					<td class="page_config">Add Name to URL:</td>
					<td class="page_config">
						<input type="checkbox" name="lm_link_add_name2url"<?php echo ($lm_link_add_name2url == 1 ? ' CHECKED':'');?> title="Check to add link name to URL." autocapitalize="off"/>
					</td>
				</tr>
				<tr>
					<td class="page_config">Enabled:</td>
					<td class="page_config">
						<input type="checkbox" name="lm_link_enabled"<?php echo ($lm_link_enabled == 1 ? ' CHECKED':'');?> title="Check to enable link, uncheck to disable link"/>
					</td>
				</tr>
			</table>
		</td>
	</tr>

	<tr class="page_config">
		<td class="page_config" style="text-align: right">
			<?php if($lm_link_id == 0) { ?>
			<button name="insert" value="insert" type="submit">Insert</button>
			<?php } else { ?>
			<button name="save" value="save" type="submit">Save</button>
			<?php	} // else ?>
			&nbsp;&nbsp;
			<button name="cancel" value="cancel" type="submit">Cancel</button>
		</td>
	</tr>

	<?php } else if(($lm_link_op == 'delete') && (isset($lm_link_id)) && ($lm_link_id > 0)) { ?>
	<tr class="page_config"><td class="page_config">&nbsp;</td></tr>
	<tr class="page_config"><th class="page_config">Delete Link - <?php echo $lm_link_name; ?></th></tr>
	<input type="hidden" name="lm_link_id" value="<?php echo $lm_link_id; ?>"/>
	<input type="hidden" name="lm_link_name" value="<?php echo htmlentities($lm_link_name); ?>"/>
	<tr class="page_config">
		<td class="page_config">
			Please confirm.
			&nbsp;&nbsp;
			<button name="confirm_delete" value="confirm_delete" type="submit">Confirm Delete</button>
			&nbsp;&nbsp;
			<button name="cancel" value="cancel" type="submit">Cancel</button>
		</td>
	</tr>
	<?php } ?>
	</form>
	<tr class="page_config"><th class="page_config">Summary</th></tr>
<!--	<tr class="page_config">
		<td class="page_config" valign="bottom">
			Filter by group name:&nbsp;
			<?php echo  Clm::gen_group_selection_list('group_edit_id',$lm_group_id,1); ?>
			&nbsp;&nbsp;
			Filter by section name:&nbsp;
			<?php echo  Clm::gen_section_selection_list('section_edit_id',$lm_section_id,'size="1"'); ?>
		</td>
	</tr>-->
	<tr class="page_config">
		<td class="page_config" style="text-align: left">
			<span id="summary_id">
				<table class="page_config">
					<tr class="page_config">
						<th width="150px" class="page_config" title="Section link is in">Section</th>
						<th width="150px" class="page_config" title="Link name">Link</th>
						<th class="page_config" style="text-align: center" title="Link image">Image</th>
						<th width="70px" class="page_config" title="Display order">Order</th>
						<!--<th width="70px" class="page_config">Enabled</th>-->
						<th width="40px" class="page_config" title="Use SSL encryption">SSL</th>
						<th width="40px" class="page_config" title="In a new tab/window">New</th>
						<th width="50px" class="page_config" title="Add name to URL">Add Name</th>
						<th class="page_config">Description</th>
					</tr>
		<?php
			$sql_query = "SELECT lm_link_id,lm_link_name,lm_link_title,lm_link_description" .
				",lm_link_section_id,lm_section_name,lm_link_new_page, lm_link_image_url" .
				",lm_section_order,lm_section_title,lm_link_order,lm_link_enabled, lm_link_ssl, lm_link_add_name2url,lm_section_enabled,lm_section_id" .
				" FROM  lm_links as l LEFT JOIN lm_sections as s ON l.lm_link_section_id = s.lm_section_id" .
				" WHERE lm_link_id > 0" .
				" AND l.lm_link_section_id = s.lm_section_id" .
				" ORDER BY lm_section_order asc,lm_link_order asc,lm_link_name asc";
			if(($result = Clm::$cDB->db_query($sql_query)) &&
				(Clm::$cDB->db_num_rows($result) > 0)) {
				$row = 0;
				while($link = Clm::$cDB->db_fetch_array($result)) {
					echo '<tr class="' . (($row & 1) ? 'page_config_odd':'page_config_even') . '">';
					echo '<td class="page_config" style="text-align: left">';
					echo '	<a href="index.php?action=edit_sections&section_edit_id=' . $link['lm_section_id'] . '" title="Click to edit section: ' . strip_tags($link['lm_section_title']) . '">' . $link['lm_section_name'] . '</a>' . (!$link['lm_section_enabled'] ? '<br>(disabled)':'');
					echo '</td>';
					echo '<td class="page_config" style="text-align: left">';
					echo '	<a href="index.php?action=edit_links&link_edit_id=' . $link['lm_link_id'] . '" title="Click to edit link: ' . strip_tags($link['lm_link_title']) . (($link['lm_link_new_page'] && LMC_SHOWINNEWTAB) ? ' (in a new tab)':'') . '">' . $link['lm_link_name'] . '</a>' . (!$link['lm_link_enabled'] ? '<br>(disabled)':'');
					echo '</td>';
					echo '<td class="page_config" style="text-align: center">';
					if((!empty($link['lm_link_image_url']))) {
						echo ' <img height="' . LMC_SMALL_IMAGE_HEIGHT . '" src="images/upload/' . $link['lm_link_image_url'] . '">';
						} else echo '&nbsp;';
					echo '</td>';
					echo '<td class="page_config" style="text-align: left">' . $link['lm_link_order'] . '</td>';
					echo '<!--<td class="page_config" style="text-align: left">' . ($link['lm_link_enabled'] ? 'yes':'no') . '</td>-->';
					echo '<td class="page_config" style="text-align: left">' . ($link['lm_link_ssl'] ? 'yes':'no') . '</td>';
					echo '<td class="page_config" style="text-align: left">' . ($link['lm_link_new_page'] ? 'yes':'no') . '</td>';
					echo '<td class="page_config" style="text-align: left">' . ($link['lm_link_add_name2url'] ? 'yes':'no') . '</td>';
					echo '<td class="page_config" style="text-align: left">' . $link['lm_link_description'] . '</td>';
					echo '</tr>' . "\n";
					$row++;
					} // while
				Clm::$cDB->db_free_result($result);
				} // if
			else echo '<tr class="page_config"><td class="page_config" style="text-align: left"><span class="msg_warning">(No links setup)</span></td></tr>' . "\n";
			?>
				</table>
			</span>
		</td>
	</tr>
	<?php if(Clm::getMsgsCount()) { ?>
	<tr class="page_config_msgs">
		<td class="page_config_msgs">
			<?php echo Clm::getMsgs(); ?>
		</td>
	</tr>
	<?php } //if ?>
</table>
</td></tr></table>

<?php Clm::page_end_comment(__FILE__); ?>
