<?php
	// $Id: edit_search.php 359 2016-04-16 19:18:52Z robert0609 $
	// Copyright BRAEWORKS (R) 2013

$results = Clm_search::get_form_results();

?>

<?php Clm::page_start_comment(__FILE__); ?>

<table class="page_container"><tr class="page_container"><td class="page_container">
<table class="page_config">
	<tr class="page_config">
		<th class="page_config" style="text-align: left">
			<h1>Admin Search</h1>
		</th>
	</tr>
	<?php if(Clm::getMsgsCount()) { ?>
	<tr class="page_config_msgs">
		<td class="page_config_msgs">
			<?php echo Clm::getMsgs(); ?>
		</td>
	</tr>
	<?php } //if ?>
	<form method="post" name="edit_search" action="<?php echo $_SERVER['PHP_SELF'] . '?action=edit_search'; ?>">
	<?php if(isset($_GET['keywords'])) echo '<input type="hidden" name="search" value="' . $_GET['keywords'] . '"/>'; ?>
	<tr class="page_config">
		<td class="page_config" style="text-align: left">
			<input type="text" name="keywords" size="40" value="<?php echo ((isset($_POST['keywords'])) ? $_POST['keywords']:((isset($_GET['search'])) ? $_GET['search']:'')); ?>" title="<?php echo Clm_search::help(); ?>" autofocus autocapitalize="off"/>
			<button name="search" value="search" type="submit" title="Start the search.">Search</button>
		</td>
	</tr>
<?php
if(!empty($results)) {
	$cnt = 0;
	$keywords = $results['keywords'];
	unset($results['keywords']);
	foreach($results as $area) {
		if(!isset($area[0])) continue;	// no result
		$title = $area['title'];
		unset($area['title']);
?>
	<tr class="page_config">
		<th class="page_config" style="text-decoration: underline;">
			<?php echo $title; ?>
		</th>
	</tr>
<?php
		for($i = 0; $i < count($area); $i++) {
?>
	<tr class="page_config">
		<td class="page_config">
			<a href="<?php echo $area[$i]['url']; ?>"><?php echo $area[$i]['text']; ?></a>
		</td>
	</tr>
<?php
			$cnt++;
			} // for
		} // foreach
	if(!$cnt) Clm::addMsg('No results found for: "' . $keywords . '"','warning');
	} // if
else {
?>
	<tr class="page_config">
		<td class="page_config">
			<?php echo Clm_search::help(); ?>
		</td>
	</tr>
	<?php	} // else ?>
	</form>
	<?php if(Clm::getMsgsCount()) { ?>
	<tr class="page_config_msgs">
		<td class="page_config_msgs">
			<?php echo Clm::getMsgs(); ?>
		</td>
	</tr>
	<?php } //if ?>
</table>
</td></tr></table>

<?php Clm::page_end_comment(__FILE__); ?>
