<?php
	// $Id: edit_sections.php 415 2016-10-16 05:48:04Z robert0609 $
	// Copyright BRAEWORKS (R) 2013

$cLMC = new Clmc();

$lm_section_id = 0;
$lm_section_op = '';
if($action == 'edit_sections') { // a bit of caution
	if(((isset($_POST['edit'])) && (isset($_POST['section_edit_id'])) && ((int)$_POST['section_edit_id'] > 0)) ||
		((isset($_GET['section_edit_id'])) && ((int)$_GET['section_edit_id'] > 0))) {
		$lm_section_op = 'edit';

		if(isset($_POST['section_edit_id'])) $lm_section_id = (int)$_POST['section_edit_id'];
		else if(isset($_GET['section_edit_id'])) $lm_section_id = (int)$_GET['section_edit_id'];
		else { // what??
			$lm_section_op = '';
			$lm_section_id = 0;
			} // else

		$sql_query = "SELECT  lm_section_name, lm_section_order,lm_section_group_ids" .
			", lm_section_name , lm_section_description, lm_section_title" .
			", lm_section_image_url, lm_section_enabled, lm_section_columns, lm_section_group_ids" .
			", DATETIME(lm_section_added, 'LocalTime') as  lm_section_added" .
			", DATETIME(lm_section_updated, 'LocalTime') as  lm_section_updated" .
			" FROM  lm_sections WHERE  lm_section_id = '" . (int)$lm_section_id . "'";
		if(($result = Clm::$cDB->db_query($sql_query)) &&
			(Clm::$cDB->db_num_rows($result) > 0) &&
			($section = Clm::$cDB->db_fetch_array($result))) {
			$lm_section_name = $section['lm_section_name'];
			$lm_section_group_ids = $section['lm_section_group_ids'];
			$lm_section_columns = (int)$section['lm_section_columns'];
			$lm_section_description = $section['lm_section_description'];
			$lm_section_title = $section['lm_section_title'];
			$lm_section_image_url = $section['lm_section_image_url'];
			$lm_section_order = $section['lm_section_order'];
			$lm_section_group_ids = $section['lm_section_group_ids'];
			$lm_section_enabled = $section['lm_section_enabled'];
			$lm_section_added = $section['lm_section_added'];
			$lm_section_updated = $section['lm_section_updated'];
			Clm::$cDB->db_free_result($result);
			} // if
		else { // not found
			$lm_section_id = 0;
			$lm_section_op = '';
			$lm_section_added = '';
			$lm_section_updated = '';
			} // else
		} // if
	else if((isset($_POST['delete'])) &&
		((isset($_POST['section_edit_id'])) || (isset($_POST['lm_section_id'])))) {
		$lm_section_op = 'delete';
		$lm_section_id = (int)(isset($_POST['lm_section_id']) ? $_POST['lm_section_id']:$_POST['section_edit_id']);

		$sql_query = "SELECT  lm_section_name,lm_section_enabled" .
					" FROM  lm_sections WHERE  lm_section_id = '" . (int)$lm_section_id . "'";
		if(($result = Clm::$cDB->db_query($sql_query)) &&
			(Clm::$cDB->db_num_rows($result) > 0) &&
			($section = Clm::$cDB->db_fetch_array($result))) {
			$lm_section_name = $section['lm_section_name'];
			$lm_section_enabled = $section['lm_section_enabled'];
			} // if
		} // else if
	else if((isset($_POST['confirm_delete'])) && (isset($_POST['lm_section_id']))) {
		$lm_section_op = 'confirm_delete';
		$lm_section_id = (int)$_POST['lm_section_id'];

		$sql_query = "DELETE FROM  lm_sections WHERE  lm_section_id = '" . (int)$lm_section_id . "'";
		Clm::$cDB->db_query($sql_query);
		new Clm_xml_sitemap();	// do sitemap
		$lm_section_id = 0;
		} // else if
	else if(isset($_POST['add'])) {
		$cols = Clm::$cDB->get_columns_list('lm_sections',true);
		foreach($cols as $c => $v) $$c = $v;
		$lm_section_op = 'add';
		$lm_section_id = 0;
		} // else if
	else if((isset($_POST['insert'])) && (isset($_POST['lm_section_id']))) {
		$lm_section_op = 'insert';
		} // else if
	else if((isset($_POST['save'])) && (isset($_POST['lm_section_id']))) {
		$lm_section_op = 'save';
		} // else if
	else if((INI_ALLOW_TABLE_RELOAD_BOOL) && (isset($_POST['reloadDB']))) {
		$lm_section_op = 'reloadDB';
		$lm_section_id = 0;
		} // else if
	else if(isset($_POST['cancel'])) {
		$lm_section_op = 'cancel';
		$lm_section_id = 0;
		} // else if
	else if(isset($_POST['import'])) {
		$lm_section_op = 'import';
		$lm_section_id = 0;
		if(Clm_export::import_sections(LM_FS_IMPORT_DIR . 'lm_sections.csv','lm_section_upload_csv')) {
			// nothing yet
			} // if
		} // else if

	if(($lm_section_op == 'save') || ($lm_section_op == 'insert')) {
		// do it once
		$lm_section_id = (int)$_POST['lm_section_id'];
		$lm_section_name = html_entity_decode($_POST['lm_section_name']);
		$lm_section_columns = (int)$_POST['lm_section_columns'];
		$lm_section_description = html_entity_decode($_POST['lm_section_description']);
		$lm_section_title = html_entity_decode($_POST['lm_section_title']);
		$lm_section_order = (int)$_POST['lm_section_order'];
		$lm_section_group_ids = implode(':',$_POST['lm_section_group_ids']);
		$lm_section_enabled = (isset($_POST['lm_section_enabled']) ? 1:0);
		$lm_section_added = html_entity_decode($_POST['lm_section_added']);
		$lm_section_updated = html_entity_decode($_POST['lm_section_updated']);
		$lm_section_image_url = $cLMC->get_image('lm_section_image_url',Clm::$cDB->get_data_in_table('lm_sections','lm_section_image_url','lm_section_id = ' . (int)$lm_section_id));

		if((empty($lm_section_name)) || (strlen($lm_section_name) < LMC_MIN_NAME_LEN)) {
			Clm::addMsg('Name too short.');
			} // if
		else if(Clm::is_section_name_inuse($lm_section_name,
			(((int)$lm_section_id > 0) ? Clm::$cDB->get_data_in_table('lm_sections','lm_section_name','lm_section_id = ' . (int)$lm_section_id):''))) {
			Clm::addMsg('Name already in use.');
			} // else if

		if((int)$lm_section_columns > 10) $lm_section_columns = 10;
		else if((int)$lm_section_columns < 1) $lm_section_columns = 1;

		if(!Clm::getMsgsCount('error')) {	// update it
			$fields = array();
			$fields['lm_section_name'] = $lm_section_name;
			$fields['lm_section_columns'] = $lm_section_columns;
			$fields['lm_section_description'] = $lm_section_description;
			$fields['lm_section_title'] = $lm_section_title;
			if(isset($lm_section_image_url)) $fields['lm_section_image_url'] = $lm_section_image_url;
			$fields['lm_section_order'] = $lm_section_order;
			$fields['lm_section_group_ids'] = $lm_section_group_ids;
			$fields['lm_section_enabled'] = $lm_section_enabled;
			if(($lm_section_op == 'insert') &&
				(!Clm::$cDB->db_perform('lm_sections',$fields,'insert',''))) {
				Clm::addMsg('Section insert, ' . $lm_section_name . " failed");
				Clm::$cDB->logEvent('ERROR: section insert, ' . $lm_section_name);
				} // if
			else if(($lm_section_op == 'save') &&
				(!Clm::$cDB->db_perform('lm_sections',$fields,'update',"lm_section_id = " . (int)$lm_section_id . ""))) {
				Clm::addMsg('Section update, ' . $lm_section_name . " failed");
				Clm::$cDB->logEvent('ERROR: section update, ' . $lm_section_name);
				} // if
			else {
				unset($_SESSION['lm_section_id']);
				Clm::addMsg('Saved section config.','success');
				Clm_export::export_sections(LM_FS_EXPORT_DIR . 'lm_sections.csv');
				} // else
			new Clm_xml_sitemap();	// do sitemap
			$lm_section_id = 0;
			$lm_section_op = '';
			} // if
		else {
			$lm_section_id = 0;
			$lm_section_op = '';
			$lm_section_added = '';
			$lm_section_updated = '';
			} // else

		} // if
	} // if
$cnt = Clm::$cDB->get_row_count_in_table('lm_sections');
?>

<?php Clm::page_start_comment(__FILE__); ?>

<table class="page_container"><tr class="page_container"><td class="page_container">
<table class="page_config">
	<tr class="page_config">
		<th class="page_config">

			<?php echo Clm::get_admin_scroll2top_anchor(false); ?>

			<h1>Sections Config</h1>
		</th>
	</tr>
	<?php if($lm_section_op == 'reloadDB') { ?>
	<tr class="page_config">
		<td class="page_config" valign="bottom">
			<?php Clm::$cDB->installDatabase('lm_sections',true ,true); ?>
		</td>
	</tr>
	<?php } // if ?>
	<?php if(Clm::getMsgsCount()) { ?>
	<tr class="page_config_msgs">
		<td class="page_config_msgs">
			<?php echo Clm::getMsgs(); ?>
		</td>
	</tr>
	<?php } //if ?>
	<form method="post" name="edit_section" action="<?php echo $_SERVER['PHP_SELF'] . '?action=edit_sections'; ?>" method="post" enctype="multipart/form-data">
	<?php if(isset($_GET['keywords'])) echo '<input type="hidden" name="search" value="' . $_GET['keywords'] . '"/>'; ?>
	<tr class="page_config">
		<td class="page_config" valign="bottom">
			Select section name:&nbsp;
			<?php echo  Clm::gen_section_selection_list('section_edit_id',$lm_section_id,'size="1"'); ?>
			<?php if($cnt > 0) { ?>
			&nbsp;&nbsp;
			<button name="edit" value="edit" type="submit">Edit</button>
			&nbsp;&nbsp;
			<button name="delete" value="delete" type="submit">Delete</button>
			<?php	} //if ?>
			&nbsp;&nbsp;
			<button name="add" value="add" type="submit">Add</button>
			<?php if(INI_ALLOW_TABLE_RELOAD_BOOL) { ?>
		</td>
	</tr>
	<tr class="page_config">
		<td class="page_config" valign="bottom">
			Sections table operations:&nbsp;
			<button name="reloadDB" value="reloadDB" type="submit" title="Clear and re-initialise sections table in database." onClick="return confirm('Clear and re-initialise sections table in database?')">Reload</button>
			<?php	} // if ?>
			<?php if(LMC_ALLOW_CSV_EXPORT_IMPORT) {
				Clm_export::export_sections(LM_FS_EXPORT_DIR . 'lm_sections.csv');
				$url = LM_SSL_URL . str_replace(LM_FS_BASE_DIR, '', LM_FS_EXPORT_DIR . 'lm_sections.csv'); ?>
			&nbsp;&nbsp;
			<button name="export" value="export" type="button" title="Download sections to a csv file." onclick="window.open('<?php echo $url; ?>');">Export</button>
<!-- @TODO			<a href="<?php echo $url; ?>" class="page_config" title="Download section csv file.">Export</a>-->
			&nbsp;&nbsp;
			<button name="import" id="import_button" value="import" type="submit" title="Upload sections to lm_sections.csv and import" onclick="return enable_import();">Import</button>
			<script type="text/javascript">
				function enable_import() {
					var b = document.getElementsByName("lm_section_upload_csv_new")[0].value;
					if(b.length < 6) {
						alert('Select sections import file first.');
						return false;
						} // if
					 return confirm('Import sections table from file?');
					} // enable_import()
			</script>
			<noscript></noscript>
			<?php echo $cLMC->input_txt_file('lm_section_upload_csv','lm_sections.csv','sqlite/export_import'); ?>
			<?php	} // if ?>
			<?php Clm_search::get_form_return_link(); ?>
		</td>
	</tr>

	<?php
	if((($lm_section_op == 'edit') || ($lm_section_op == 'save') ||
		($lm_section_op == 'add') || ($lm_section_op == 'insert')) &&
		(isset($lm_section_id))) {
	?>
	<tr class="page_config">
		<th class="page_config">
			<?php if($lm_section_id == 0) {
				echo 'Add Section';
				} // if
			else {
				echo 'Edit Section' .
					'&nbsp;&nbsp;<span class="page_config">(Added:&nbsp;' . $lm_section_added .
					'&nbsp;&nbsp;Updated:&nbsp;' . $lm_section_updated . ')</span>';
				if((isset($_GET['name'])) && ($_GET['name'] == $lm_section_name))
					echo '&nbsp;&nbsp;<span class="msg_success"><img src="images/success.gif">Found here</span>' .
						'&nbsp;&nbsp;<a href="index.php?action=edit_search&search=' . $_GET['keywords'] . '" title="Search for:' . urldecode ($_GET['keywords']) . '">Return to search.</a>';
				} // else
			?>
		</th>
	</tr>
	<input type="hidden" name="lm_section_id" value="<?php echo $lm_section_id; ?>"/>
	<input type="hidden" name="lm_section_name_old" value="<?php echo htmlentities($lm_section_name); ?>"/>
	<input type="hidden" name="lm_section_added" value="<?php echo htmlentities($lm_section_added); ?>"/>
	<input type="hidden" name="lm_section_updated" value="<?php echo htmlentities($lm_section_updated); ?>"/>
	<tr>
		<td>
			<table class="page_config">
				<tr>
					<td width ="100px" class="page_config" valign="top">Select group/s:</td>
					<td class="page_config">
						<?php echo  Clm::gen_group_selection_list('lm_section_group_ids[]',$lm_section_group_ids, 10, ' multiple'); ?>
					</td>
				</tr>
				<tr>
					<td width ="100px" class="page_config">Name:</td>
					<td class="page_config">
						<input type="text" name="lm_section_name" size="40" value="<?php echo $lm_section_name; ?>" title="Unique section name. Appears on page as a section heading. Minimum of 4 charaters." autocapitalize="off"/>
					</td>
				</tr>
				<tr>
					<td width ="100px" class="page_config">Columns:</td>
					<td class="page_config">
						<input type="text" name="lm_section_columns" size="8" value="<?php echo $lm_section_columns; ?>" title="Number of columns across the page for links in this section. Maximum of 10 columns." autocapitalize="off"/>
					</td>
				</tr>
				<tr>
					<td class="page_config">Description:</td>
					<td class="page_config">
						<input type="text" name="lm_section_description" size="80" value="<?php echo $lm_section_description; ?>" title="Section description (optional), appears under the name." autocapitalize="off"/>
					</td>
				</tr>
				<tr>
					<td class="page_config">Title:</td>
					<td class="page_config">
						<input type="text" name="lm_section_title" size="80" value="<?php echo $lm_section_title; ?>" title="Section title (optional), appears when mouse is hovered over section name or image." autocapitalize="off"/>
					</td>
				</tr>
				<tr>
					<td class="page_config">Image URL:</td>
					<td class="page_config" title="Section image or icon (optional). Images are stored in the images/upload/ directory.">
						<?php echo $cLMC->input_image('lm_section_image_url', $lm_section_image_url); ?>
					</td>
				</tr>
				<tr>
					<td class="page_config">Display Order:</td>
					<td class="page_config">
						<input type="text" name="lm_section_order" size="5" value="<?php echo $lm_section_order; ?>" title="Sorting order of section. Used to control the order of the section. Low numbers at the top of the page, ascending down the page." autocapitalize="off"/>
					</td>
				</tr>
				<tr>
					<td class="page_config">Enabled:</td>
					<td class="page_config">
						<input type="checkbox" name="lm_section_enabled"<?php echo ($lm_section_enabled == 1 ? ' CHECKED':'');?> title="Check to enable section, uncheck to disable section (all links under the section are also disabled)"/>
					</td>
				</tr>
			</table>
		</td>
	</tr>

	<tr class="page_config">
		<td class="page_config" style="text-align: right">
			<?php if($lm_section_id == 0) { ?>
			<button name="insert" value="insert" type="submit">Insert</button>
			<?php } else { ?>
			<button name="save" value="save" type="submit">Save</button>
			<?php	} // else ?>
			&nbsp;&nbsp;
			<button name="cancel" value="cancel" type="submit">Cancel</button>
		</td>
	</tr>
	<?php } else if(($lm_section_op == 'delete') && (isset($lm_section_id)) && ($lm_section_id > 0)) { ?>
	<tr class="page_config"><th class="page_config">Delete Section - <?php echo $lm_section_name; ?></th></tr>
	<input type="hidden" name="lm_section_id" value="<?php echo $lm_section_id; ?>"/>
	<input type="hidden" name="lm_section_name" value="<?php echo htmlentities($lm_section_name); ?>"/>
	<tr class="page_config">
		<td class="page_config">
			Please confirm.
			&nbsp;&nbsp;
			<button name="confirm_delete" value="confirm_delete" type="submit">Confirm Delete</button>
			&nbsp;&nbsp;
			<button name="cancel" value="cancel" type="submit">Cancel</button>
		</td>
	</tr>
	<?php	} ?>
	</form>
	<tr class="page_config"><th class="page_config">Summary</th></tr>
	<tr class="page_config">
		<td class="page_config" style="text-align: left">
			<table class="page_config">
				<tr class="page_config">
					<th width ="150px" class="page_config" title="Section name">Section</th>
					<th class="page_config" style="text-align: center" title="Section image">Image</th>
					<th width ="70px" class="page_config" title="Display order">Order</th>
					<!--<th width ="70px" class="page_config">Enabled</th>-->
					<th width ="70px" class="page_config">Columns</th>
					<th class="page_config">Groups</th>
					<th class="page_config">Description</th>
				</tr>
	<?php
		$sql_query = "SELECT  lm_section_id,lm_section_name,lm_section_columns,lm_section_group_ids" .
			",lm_section_title,lm_section_description, lm_section_order, lm_section_enabled, lm_section_image_url" .
			" FROM  lm_sections ORDER BY  lm_section_order,lm_section_id";
		if(($result = Clm::$cDB->db_query($sql_query)) &&
			(Clm::$cDB->db_num_rows($result) > 0)) {
			$row = 0;
			while($section = Clm::$cDB->db_fetch_array($result)) {
				echo '<tr class="' . (($row & 1) ? 'page_config_odd':'page_config_even') . '">';
				echo '<td class="page_config" style="text-align: left">';
				echo '	<a href="index.php?action=edit_sections&section_edit_id=' . $section['lm_section_id'] . '" title="' . strip_tags($section['lm_section_title']) . '">' . $section['lm_section_name'] . '</a>' . (!$section['lm_section_enabled'] ? '<br>(disabled)':'');
				echo '</td>';
				echo '<td class="page_config" style="text-align: center">';
				if((!empty($section['lm_section_image_url']))) {
					echo ' <img height="' . LMC_SMALL_IMAGE_HEIGHT . '" src="images/upload/' . $section['lm_section_image_url'] . '">';
					} else echo '&nbsp;';
				echo '</td>';
				echo '<td class="page_config" style="text-align: left">' . $section['lm_section_order'] . ' </td>';
				echo '<!--<td class="page_config" style="text-align: left">' . ($section['lm_section_enabled'] ? 'yes':'no') . ' </td>-->';
				echo '<td class="page_config" style="text-align: left">' . $section['lm_section_columns'] . ' </td>';
				echo '<td class="page_config">' . Clm::get_group_ids_text($section['lm_section_group_ids'],false) . '</td>';
				echo '<td class="page_config" style="text-align: left">' . $section['lm_section_description'] . '</td>';
				echo '</tr>' . "\n";
				$row++;
				} // while
			} // if
		else echo '<tr class="page_config"><td class="page_config" style="text-align: left"><span class="msg_warning">(No sections setup)</span></td></tr>' . "\n";
		?>
			</table>
		</td>
	</tr>
	<?php if(Clm::getMsgsCount()) { ?>
	<tr class="page_config_msgs">
		<td class="page_config_msgs">
			<?php echo Clm::getMsgs(); ?>
		</td>
	</tr>
	<?php } //if ?>
</table>
</td></tr></table>

<?php Clm::page_end_comment(__FILE__); ?>
