<?php
	// $Id: edit_users.php 415 2016-10-16 05:48:04Z robert0609 $
	// Copyright BRAEWORKS (R) 2013

$lm_user_id = 0;
$lm_user_op = '';
if($action == 'edit_users') { // a bit of caution
	if(((isset($_POST['edit'])) && (isset($_POST['user_edit_id'])) && ((int)$_POST['user_edit_id'] > 0)) ||
		((isset($_GET['user_edit_id'])) && ((int)$_GET['user_edit_id'] > 0))) {
		$lm_user_op = 'edit';

		if(isset($_POST['user_edit_id'])) $lm_user_id = (int)$_POST['user_edit_id'];
		else if(isset($_GET['user_edit_id'])) $lm_user_id = (int)$_GET['user_edit_id'];
		else { // what??
			$lm_user_op = '';
			$lm_user_id = 0;
			} // else

		$sql_query = "SELECT  lm_user_name,lm_user_enabled, lm_user_admin, lm_user_group_ids,lm_user_inline_html" .
			", DATETIME(lm_user_added, 'LocalTime') as  lm_user_added" .
			", DATETIME(lm_user_updated, 'LocalTime') as  lm_user_updated" .
			" FROM  lm_users WHERE  lm_user_id = '" . (int)$lm_user_id . "'";
		if(($result = Clm::$cDB->db_query($sql_query)) &&
			(Clm::$cDB->db_num_rows($result) > 0) &&
			($user = Clm::$cDB->db_fetch_array($result))) {
			$lm_user_name = $user['lm_user_name'];
			$lm_user_group_ids = $user['lm_user_group_ids'];
			$lm_user_admin = $user['lm_user_admin'];
			$lm_user_enabled = $user['lm_user_enabled'];
			$lm_user_inline_html = $user['lm_user_inline_html'];
			$lm_user_added = $user['lm_user_added'];
			$lm_user_updated = $user['lm_user_updated'];
			Clm::$cDB->db_free_result($result);
			} // if
		else { // not found
			$lm_user_id = 0;
			$lm_user_op = '';
			$lm_user_added = '';
			$lm_user_updated = '';
			} // else
		} // if
	else if((isset($_POST['delete'])) &&
		((isset($_POST['user_edit_id'])) || (isset($_POST['lm_user_id'])))) {
		$lm_user_op = 'delete';
		$lm_user_id = (int)(isset($_POST['lm_user_id']) ? $_POST['lm_user_id']:$_POST['user_edit_id']);

		$sql_query = "SELECT  lm_user_name, lm_user_admin, lm_user_enabled" .
					" FROM  lm_users WHERE  lm_user_id = '" . (int)$lm_user_id . "'";
		if(($result = Clm::$cDB->db_query($sql_query)) &&
			(Clm::$cDB->db_num_rows($result) > 0) &&
			($user = Clm::$cDB->db_fetch_array($result))) {
			$lm_user_name = $user['lm_user_name'];
			$lm_user_admin = $user['lm_user_admin'];
			$lm_user_enabled = $user['lm_user_enabled'];
			} // if
		} // else if
	else if((isset($_POST['confirm_delete'])) && (isset($_POST['lm_user_id']))) {
		$lm_user_op = 'confirm_delete';
		$lm_user_id = (int)$_POST['lm_user_id'];

		$sql_query = "DELETE FROM  lm_users WHERE  lm_user_id = '" . (int)$lm_user_id . "'";
		Clm::$cDB->db_query($sql_query);
		$lm_user_id = 0;
		} // else if
	else if(isset($_POST['add'])) {
		$cols = Clm::$cDB->get_columns_list('lm_users',true);
		foreach($cols as $c => $v) $$c = $v;
		$lm_user_op = 'add';
		$lm_user_id = 0;
		} // else if
	else if((isset($_POST['insert'])) && (isset($_POST['lm_user_id']))) {
		$lm_user_op = 'insert';
		} // else if
	else if((isset($_POST['save'])) && (isset($_POST['lm_user_id']))) {
		$lm_user_op = 'save';
		} // else if
	else if((INI_ALLOW_TABLE_RELOAD_BOOL) && (isset($_POST['reloadDB']))) {
		$lm_user_op = 'reloadDB';
		$lm_user_id = 0;
		} // else if
	else if(isset($_POST['cancel'])) {
		$lm_user_op = 'cancel';
		$lm_user_id = 0;
		} // else if

	if(($lm_user_op == 'insert') || ($lm_user_op == 'save')) {

		$lm_user_id = (int)$_POST['lm_user_id'];
		$lm_user_name = html_entity_decode($_POST['lm_user_name']);
		$lm_user_name_old = html_entity_decode($_POST['lm_user_name_old']);
		$lm_user_group_ids = implode(':',$_POST['lm_user_group_ids']);
		$lm_user_password = html_entity_decode($_POST['lm_user_password']);
		$lm_user_confirm = html_entity_decode($_POST['lm_user_confirm']);
		$lm_user_admin = (isset($_POST['lm_user_admin']) ? 1:0);
		$lm_user_enabled = (isset($_POST['lm_user_enabled']) ? 1:0);
		$lm_user_inline_html = (isset($_POST['lm_user_inline_html']) ? 1:0);
		$lm_user_added = html_entity_decode($_POST['lm_user_added']);
		$lm_user_updated = html_entity_decode($_POST['lm_user_updated']);

		// check to see that there is always an administrator
		$admin_cnt = Clm::$cDB->get_row_count_in_table('lm_users','lm_user_admin > 0 AND lm_user_enabled > 0');
		if(($lm_user_name == $_SESSION['user']['name']) &&
			($lm_user_op == 'save') &&
			(!$lm_user_admin)) {	// check I am NOT the last admin
			if((int)$admin_cnt <= 1) {
				$lm_user_admin = 1;
				Clm::addMsg('You are the last administrator, cannot disable adminitrator.','warning');
				} // if
			else Clm::addMsg('You are longer an administrator after you log out.','warning');
			} // if
		if((int)$admin_cnt <= 1) {
			Clm::addMsg('No available administrators, you are now an adminitrator.','info');
			$fields = array();
			$fields['lm_user_enabled'] = 1;
			$fields['lm_user_admin'] = 1;
			Clm::$cDB->db_perform('lm_users',$fields,'update',"lm_user_id = " . (int)$_SESSION['user']['id'] . "");
			} // if

		if($lm_user_op == 'save') {
			if(strlen($lm_user_password) > 0 || strlen($lm_user_confirm) > 0) {
				if(strlen($lm_user_password) < LMC_MIN_PASSWD_LEN) {
					Clm::addMsg('Password too short.');
					} // else if
				else if($lm_user_password != $lm_user_confirm) {
					Clm::addMsg('Password/confirm error.');
					} // if
				} // if
			if((empty($lm_user_name)) || (strlen($lm_user_name) < LMC_MIN_NAME_LEN)) {
				Clm::addMsg('Name too short.');
				} // if
			else if(Clm::is_user_name_inuse($lm_user_name,
				(((int)$lm_user_id > 0) ? Clm::$cDB->get_data_in_table('lm_users','lm_user_name','lm_user_id = ' . (int)$lm_user_id):''))) {
				Clm::addMsg('Name already in use.');
				} // else if
			} // if
		else if($lm_user_op == 'insert') {
			if((empty($lm_user_password)) && (empty($lm_user_confirm))) {
				Clm::addMsg('User will be challenged for password on first login.','warning');
				} // if
			else if(strlen($lm_user_password) < LMC_MIN_PASSWD_LEN) {
				Clm::addMsg('Password too short.');
				} // else if
			else if($lm_user_password != $lm_user_confirm) {
				Clm::addMsg('Password/confirm error.');
				} // if
			if((empty($lm_user_name)) || (strlen($lm_user_name) < LMC_MIN_NAME_LEN)) {
				Clm::addMsg('Name too short.');
				} // if
			else if(Clm::is_user_name_inuse($lm_user_name)) {
				Clm::addMsg('Name already in use.');
				} // else if
			} // else

		if(!Clm::getMsgsCount('error')) {	// update it
			$fields = array();
			$fields['lm_user_name'] = $lm_user_name;
			$fields['lm_user_group_ids'] = $lm_user_group_ids;
			if(strlen($lm_user_password) > 0) $fields['lm_user_password_md5'] = md5($lm_user_password);
			else $fields['lm_user_password_md5'] = "FirstTimeLogin";
			$fields['lm_user_enabled'] = $lm_user_enabled;
			$fields['lm_user_admin'] = $lm_user_admin;
			$fields['lm_user_inline_html'] = $lm_user_inline_html;

			if($lm_user_op == 'insert') {
				if(!Clm::$cDB->db_perform('lm_users',$fields,'insert','')) {
					Clm::addMsg('User insert, ' . $lm_user_name . " failed");
					Clm::$cDB->logEvent('ERROR: user insert, ' . $lm_user_name);
					} // if
				else {
					unset($_SESSION['lm_user_id']);
					echo '<span class="page_config_msgs">' . 'INFO: New user data saved.</span>' . LM_NL;
					} // else
				} // if
			else if($lm_user_op = 'save') {
				if(!Clm::$cDB->db_perform('lm_users',$fields,'update',"lm_user_id = " . (int)$lm_user_id . "")) {
					Clm::addMsg('User update, ' . $lm_user_name . " failed");
					Clm::$cDB->logEvent('ERROR: user update, ' . $lm_user_name);
					} // if
				else {
					unset($_SESSION['lm_user_id']);
					Clm::addMsg('Saved user data.','success');
					} // else
				} else
			$lm_user_id = 0;
			$lm_user_op = '';
			} // if
		} // if
	} // if
$cnt = Clm::$cDB->get_row_count_in_table('lm_users');
?>

<?php Clm::page_start_comment(__FILE__); ?>

<table class="page_container"><tr class="page_container"><td class="page_container">
<table class="page_config">
	<tr class="page_config">
		<th class="page_config">

			<?php echo Clm::get_admin_scroll2top_anchor(false); ?>

			<h1>Users</h1>
		</th>
	</tr>
	<?php if($lm_user_op == 'reloadDB') { ?>
	<tr class="page_config">
		<td class="page_config" valign="bottom">
			<?php Clm::$cDB->installDatabase('lm_users',true ,true); ?>
		</td>
	</tr>
	<?php } // if ?>
	<?php if(Clm::getMsgsCount()) { ?>
	<tr class="page_config_msgs">
		<td class="page_config_msgs">
			<?php echo Clm::getMsgs(); ?>
		</td>
	</tr>
	<?php } //if ?>
	<form method="post" name="edit_user" action="<?php echo $_SERVER['PHP_SELF'] . '?action=edit_users'; ?>" method="post" enctype="multipart/form-data" autocomplete="off">
	<?php if(isset($_GET['keywords'])) echo '<input type="hidden" name="search" value="' . $_GET['keywords'] . '"/>'; ?>
	<tr class="page_config">
		<td class="page_config" valign="bottom">
			Select user name:&nbsp;
			<?php echo  Clm::gen_user_selection_list('user_edit_id',$lm_user_id,'size="1"'); ?>
			<?php if($cnt > 0) { ?>
			&nbsp;&nbsp;
			<button name="edit" value="edit" type="submit">Edit</button>
			&nbsp;&nbsp;
			<button name="delete" value="delete" type="submit">Delete</button>
			<?php	} //if ?>
			&nbsp;&nbsp;
			<button name="add" value="add" type="submit">Add</button>
			<?php if(INI_ALLOW_TABLE_RELOAD_BOOL) { ?>
			&nbsp;&nbsp;
			<button name="reloadDB" value="reloadDB" type="submit" title="Clear and re-initialise users table in database." onClick="return confirm('Clear and re-initialise users table in database?')">Reload</button>
			<?php	} // if ?>
			<?php Clm_search::get_form_return_link(); ?>
		</td>
	</tr>

	<?php
	if((($lm_user_op == 'edit') || ($lm_user_op == 'save') ||
		($lm_user_op == 'add') || ($lm_user_op == 'insert')) &&
		(isset($lm_user_id))) {
	?>
	<tr class="page_config">
		<th class="page_config">
			<?php if($lm_user_id == 0) {
				echo 'Add User';
				} // if
			else {
				echo 'Edit User' .
					'&nbsp;&nbsp;<span class="page_config">(Added:&nbsp;' . $lm_user_added .
					'&nbsp;&nbsp;Updated:&nbsp;' . $lm_user_updated . ')</span>';
				if((isset($_GET['name'])) && ($_GET['name'] == $lm_user_name))
					echo '&nbsp;&nbsp;<span class="msg_success"><img src="images/success.gif">Found here</span>' .
						'&nbsp;&nbsp;<a href="index.php?action=edit_search&search=' . $_GET['keywords'] . '" title="Search for:' . urldecode ($_GET['keywords']) . '">Return to search.</a>';
				} // else
			?>
		</th>
	</tr>
	<input type="hidden" name="lm_user_id" value="<?php echo $lm_user_id; ?>"/>
	<input type="hidden" name="lm_user_name_old" value="<?php echo htmlentities($lm_user_name); ?>"/>
	<input type="hidden" name="lm_user_added" value="<?php echo (isset($lm_user_added) ? htmlentities($lm_user_added):''); ?>"/>
	<input type="hidden" name="lm_user_updated" value="<?php echo (isset($lm_user_updated) ? htmlentities($lm_user_updated):''); ?>"/>
	</tr>
	<tr class="page_config">
		<td class="page_config">
			<table class="page_config">
				<tr>
					<td width ="100px" class="page_config" valign="top">Select group/s:</td>
					<td class="page_config">
						<?php echo  Clm::gen_group_selection_list('lm_user_group_ids[]',$lm_user_group_ids,10, ' multiple'); ?>
					</td>
				</tr>
				<tr>
					<td width ="100px" class="page_config">Name:</td>
					<td class="page_config">
						<input type="text" name="lm_user_name" value="<?php echo $lm_user_name; ?>"  autocorrect="off" autocapitalize="off"
							   title="Enter username. Minimum of 4 characters.<?php echo ((LMC_USE_FIRST_LOGIN_ALWAYS && $lm_user_id == 0) ? '\nPassword is entered by user at first login.':''); ?>" autocapitalize="off"/>
					</td>
				</tr>
<?php if(!LMC_USE_FIRST_LOGIN_ALWAYS) {	?>
				<tr>
					<td width ="100px" class="page_config">Password:</td>
					<td class="page_config">
						<input type="password" name="lm_user_password" value="" autocomplete="off"
							   title="<?php echo (($lm_user_id == 0) ? 'Enter password or leave for user to enter password on first login.':'Leave blank to have password unchanged') ?>, minimum of 4 character."/>
					</td>
				</tr>
				<tr>
					<td width ="100px" class="page_config">Confirm:</td>
					<td class="page_config">
						<input type="password" name="lm_user_confirm" value="" autocomplete="off"
							   title="Confirm password, minimum of 4 characters."/>
					</td>
				</tr>
<?php	} // if
 else { ?>
				<input type="hidden" name="lm_user_password" value=""/>
				<input type="hidden" name="lm_user_confirm" value=""/>
<?php	} // else ?>
<?php if((isset($_SESSION['user']['admin'])) && ((int)$_SESSION['user']['admin'] > 0)) { ?>
				<tr>
					<td width ="100px" class="page_config">Administrator:</td>
					<td class="page_config">
						<input type="checkbox" name="lm_user_admin"<?php echo ($lm_user_admin == true ? ' CHECKED':'');?>/>
					</td>
				</tr>
<?php	} // if ?>
				<tr>
					<td width ="100px" class="page_config">Enabled:</td>
					<td class="page_config">
						<input type="checkbox" name="lm_user_enabled"<?php echo ($lm_user_enabled == true ? ' CHECKED':'');?>/>
					</td>
				</tr>
				<tr>
					<td width ="100px" class="page_config">Inline HTML:</td>
					<td class="page_config">
						<input type="checkbox" name="lm_user_inline_html"<?php echo ($lm_user_inline_html == true ? ' CHECKED':'');?> title="User will need to logout and login again for changes to take effect"/>
					</td>
				</tr>
			</table>
		</td>
	</tr>

	<tr class="page_config">
		<td class="page_config" style="text-align: right">
			<?php if($lm_user_id == 0) { ?>
			<button name="insert" value="insert" type="submit">Insert</button>
			<?php } else { ?>
			<button name="save" value="save" type="submit">Save</button>
			<?php	} // else ?>
			&nbsp;&nbsp;
			<button name="cancel" value="cancel" type="submit">Cancel</button>
		</td>
	</tr>
	<?php } else if(($lm_user_op == 'delete') && (isset($lm_user_id)) && ($lm_user_id > 0)) { ?>
	<tr class="page_config"><th class="page_config">Delete <?php echo ($lm_user_admin ? 'Administrator':'User'); ?> - <?php echo $lm_user_name; ?></th></tr>
	<input type="hidden" name="lm_user_id" value="<?php echo $lm_user_id; ?>"/>
	<input type="hidden" name="lm_user_name" value="<?php echo htmlentities($lm_user_name); ?>"/>
	<tr class="page_config">
		<td class="page_config">
			Please confirm.
			&nbsp;&nbsp;
			<button name="confirm_delete" value="confirm_delete" type="submit">Confirm Delete</button>
			&nbsp;&nbsp;
			<button name="cancel" value="cancel" type="submit">Cancel</button>
		</td>
	</tr>
	<?php }  ?>
	</form>
	<tr class="page_config"><th class="page_config">Summary</th></tr>
	<tr class="page_config">
		<td class="page_config" style="text-align: left">
			<table class="page_config">
				<tr class="page_config">
					<th width ="120px" class="page_config">User</th>
					<th width ="70px" class="page_config">Enabled</th>
					<th width ="70px" class="page_config" title="Number of logins.">Logins</th>
					<th width ="70px" class="page_config">Last Login</th>
					<th width ="70px" class="page_config" title="Global web site administrator.">Admin</th>
					<th width ="70px" class="page_config" title="Inline; page height is the document length, Block; page height between fixed header and footer.">HTML</th>
					<th class="page_config">Groups</th>
				</tr>
	<?php
		$sql_query = "SELECT  lm_user_id,lm_user_name,lm_user_group_ids,lm_user_enabled,lm_user_login_count" .
			", DATETIME(lm_user_updated, 'LocalTime') as  updated" .
			",lm_user_updated,lm_user_admin,lm_user_inline_html" .
			" FROM  lm_users ORDER BY  lm_user_name,lm_user_id";
		if(($result = Clm::$cDB->db_query($sql_query)) &&
			(Clm::$cDB->db_num_rows($result) > 0)) {
			$row = 0;
			while($user = Clm::$cDB->db_fetch_array($result)) {
				echo '<tr class="' . (($row & 1) ? 'page_config_odd':'page_config_even') . '">';
				echo '<td class="page_config">';
				echo '<a href="index.php?action=edit_users&user_edit_id=' . $user['lm_user_id'] . '">' . $user['lm_user_name'] . '</a>';
				echo '</td>';
				echo '<td class="page_config">' . ($user['lm_user_enabled'] ? 'yes':'no') . '</td>';
				echo '<td class="page_config">' . $user['lm_user_login_count'] . '</td>';
				echo '<td class="page_config">' . $user['updated'] . '</td>';
				echo '<td class="page_config">' . ($user['lm_user_admin'] ? 'yes':'no') . '</td>';
				echo '<td class="page_config">' . ($user['lm_user_inline_html'] ? 'inline':'block') . '</td>';
				echo '<td class="page_config">' . Clm::get_group_ids_text($user['lm_user_group_ids'],false) . '</td>';
				echo '</td></tr>' . "\n";
				$row++;
				} // while
			Clm::$cDB->db_free_result($result);
			} // if
		else echo '<tr class="page_config"><td class="page_config" style="text-align: left"><span class="msg_warning">(No users setup)</span></td></tr>' . "\n";
		?>
			</table>
		</td>
	</tr>
	<?php if(Clm::getMsgsCount()) { ?>
	<tr class="page_config_msgs">
		<td class="page_config_msgs">
			<?php echo Clm::getMsgs(); ?>
		</td>
	</tr>
	<?php } //if ?>
</table>
</td></tr></table>

<?php Clm::page_end_comment(__FILE__); ?>
